package gov.va.med.mhv.admin.service.mhvusers;


import gov.va.med.mhv.common.api.dto.FacilityInfoDTO;
import gov.va.med.mhv.common.api.exception.MHVException;

import java.util.List;


public interface FacilityInfoService {

	/**
	 * Save the FacilityInfo
	 *
	 * @param entity FacilityInfo to save
	 * @return FacilityInfo The saved FacilityInfo
	 */
	public FacilityInfoDTO saveFacilityInfo(FacilityInfoDTO facilityInfo);
	
	/**
	 * Delete the FacilityInfo
	 *
	 * @param entity FacilityInfo to delete
	 * @return FacilityInfo The deleted FacilityInfo
	 */
	//public FacilityInfoBO delete(FacilityInfoPK pk);
	
	/**
	 * Find the FacilityInfo by primary key fields
	 *
	 * @param pk The primary key for the FacilityInfo
	 * @return FacilityInfo The retrieved FacilityInfo
	 */
	//public FacilityInfoBO findByPrimaryKey(FacilityInfoPK pk);

	/**
	 * Execute the getAllFacilityInfos query
	 *
	 * @return List of FacilityInfos
	 */	 
	public List<FacilityInfoDTO> getAllFacilityInfos();

	/**
	 * Execute the queryByStationNumber query
	 *
	 * @param stationNumber The stationNumber
	 * @return List of FacilityInfos
	 */	 
	public List<FacilityInfoDTO> queryByStationNumber(String stationNumber);
	
	public FacilityInfoDTO getFacilityInfoById(Long facilityInfoId)  throws MHVException;
}
