package gov.va.med.mhv.admin.service.mhvusers;


import java.util.Date;
import java.util.List;

import gov.va.med.mhv.admin.dto.SMSUserViewDTO;
import gov.va.med.mhv.admin.dto.TermsConditionsVerHistDTO;
import gov.va.med.mhv.admin.dto.UserAcceptExtTermsVerDTO;
import gov.va.med.mhv.admin.dto.UserAcceptTermsHistDTO;
import gov.va.med.mhv.admin.dto.UserProfileDeactivationAuditDTO;
import gov.va.med.mhv.common.api.dto.UserProfileDTO;
import gov.va.med.mhv.common.api.dto.UserProfileDeactivationReasonDTO;
import gov.va.med.mhv.common.api.exception.MHVException;

public interface UserProfileService {

	public List<UserProfileDTO> searchUserExtended(UserProfileDTO userProfileDTO) throws MHVException;

	public List<UserProfileDTO> searchUserIPAExtended(UserProfileDTO userProfileDTO) throws MHVException;
		
	public UserProfileDTO findUserProfileById(Long userProfileId) throws MHVException;
	
	public void resetPassword(String userName, String newPassword) throws MHVException;

	public List<UserProfileDeactivationAuditDTO> findUserProfileDeactivationAuditByUser(Long userProfileId)
			throws MHVException;

	public Boolean userhasDeletedAccount(Long userProfileId) throws MHVException;

	public UserProfileDTO restrictSipAccess(UserProfileDTO userProfile) throws MHVException;

	public void reactivateUserInHelpDesk(Long userProfileId, Integer reasonId, String changedBy, String notes)
			throws MHVException;

	public void changeActivationState(Long userProfileId, Integer reasonId, String changedBy, String notes, String deathDate,Boolean isActivate)
			throws MHVException;

	public SMSUserViewDTO getSMUser(String userName) throws MHVException;

	public UserProfileDeactivationReasonDTO findDeactivationReason(Integer reasonId) throws MHVException;
	
	public List<UserAcceptTermsHistDTO> findUserAcceptTermsHistByUserProfileId(Long userProfileId) throws MHVException;
	
	public List<TermsConditionsVerHistDTO> findTermsConditionsVerHistById(Long termsConditionsVerHistId) throws MHVException;

	public List<UserAcceptExtTermsVerDTO> findUserAcceptExtTermsVerByUserProfileId(Long userProfileId) throws MHVException;

}
