/**
 * 
 */
package gov.va.med.mhv.admin.converter;

import java.util.ArrayList;
import java.util.List;

import gov.va.med.mhv.admin.dto.ActivityDTO;
import gov.va.med.mhv.admin.dto.EmployeeOrgRoleDTO;
import gov.va.med.mhv.admin.model.Activity;
import gov.va.med.mhv.admin.model.EmployeeOrgRole;

import org.springframework.core.convert.converter.Converter;
import org.springframework.stereotype.Component;

/**
 * @author vhaislegberb
 *
 */
@Component
public class ActivityDTOConverter implements Converter<ActivityDTO, Activity> {
	
	private final static int DETAIL_VALUE_MAX_LENGTH = 255;

	@Override
	public Activity convert(ActivityDTO source) {
		Activity destination = new Activity();
		destination.setAction(source.getAction());
		destination.setActivityId(source.getActivityId());
		destination.setActivityType(source.getActivityType());
		destination.setCompletionTime(source.getCompletionTime());
		if(source.getDetailValue() != null) {
			destination.setDetailValue(abbreviateString(source.getDetailValue(),DETAIL_VALUE_MAX_LENGTH));
		}
		destination.setPerformerType(source.getPerformerType());
		destination.setStatus(source.getStatus());
		destination.setUserProfileId(source.getUserProfileId());
		return destination;
	}
	
	public ActivityDTO convert(Activity source) {
		ActivityDTO destination = new ActivityDTO();
		destination.setAction(source.getAction());
		destination.setActivityId(source.getActivityId());
		destination.setActivityType(source.getActivityType());
		System.out.println("%%%%%%%%%%%%%%%%%%%%%%%%%"+ destination.getActivityType());
		destination.setCompletionTime(source.getCompletionTime());
		if(source.getDetailValue() != null) {
			destination.setDetailValue(abbreviateString(source.getDetailValue(),DETAIL_VALUE_MAX_LENGTH));
		}
		destination.setPerformerType(source.getPerformerType());
		destination.setStatus(source.getStatus());
		destination.setUserProfileId(source.getUserProfileId());
		return destination;
	}
	
		public List<ActivityDTO> convertList(List<Activity> source) {
    	
    	List<ActivityDTO> destination = new ArrayList<ActivityDTO>();
    	for(Activity a : source) {
			destination.add(convert(a));
		}
		return destination;
	}
	
	private static String abbreviateString(String input, int maxLength) {
	    if (input.length() <= maxLength) 
	        return input;
	    else 
	        return input.substring(0, maxLength-2) + "..";
	}

}
