package gov.va.med.mhv.admin.handler;

import java.io.Serializable;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.PropertySource;
import org.springframework.stereotype.Component;

import gov.va.med.mhv.common.props.WeblogicJndiDataSourcePropertySourceFactory;

@Component
@PropertySource(value="MHVDB", name="jdbc/mhvDS:ADMIN_PORTAL_WS", factory=WeblogicJndiDataSourcePropertySourceFactory.class)
public class MviProperties implements Serializable {

	private static final long serialVersionUID = 3267951548902626919L;

	@Value("${mvi.enabled}")
	private boolean isMviEnabled;

	@Value("${mvi.wsdlurl}")
	private String mviWsdlUrl;

	@Value("${mvi.connect.timeout}")
	private Integer mviConnectTimeout;

	@Value("${mvi.request.timeout}")
	private Integer mviRequestTimeout;

	@Value("${mvi.env.type}")
	private String mviEnvType;

	@Value("${mvi.mock.search.enabled}")
	private Boolean isMviMockSearchEnabled;

	@Value("${mvi.mock.getcorrespond.enabled}")
	private Boolean isMviMockCorrespondingEnabled;

	@Value("${mvi.mock.correlation.enabled}")
	private Boolean isMviMockCorrelationEnabled;

	@Value("${mvi.interaction.id}")
	private String mviInteractionId;

	@Value("${va.oid.value}")
	private String vaOidValue;

	@Value("${mvi.root.id}")
	private String mviRootId;

	@Value("${mvi.receiving.facility}")
	private String mviReceivingFacilityId;

	@Value("${mvi.usssa.identifier.id}")
	private String mviUsssaIdentifierId;

	@Value("${mvi.facility.assigning.authority}")
	private String mviFacilityAssignAuthority;

	@Value("${mvi.patient.identifier}")
	private String mviPatientIdentifier;

	@Value("${mvi.national.identifier}")
	private String mviNationalIdentifier;

	@Value("${mvi.prod.dodroot.id}")
	private String mviProdDodrootId;

	@Value("${mvi.nonprod.dodroot.id}")
	private String mviNonprodDodrootId;

	@Value("${mvi.facilities.update.max.count}")
	private int mviFacilitiesUpdateMaxCount;
	
	//EMAIL
	
	@Value("${email.service.smtp.host}")
	private String smtpHost;
	
	@Value("${email.service.smtp.debug}")
	private Boolean smtpDebug;

	
	public boolean isMviEnabled() {
		return isMviEnabled;
	}

	public void setMviEnabled(boolean isMviEnabled) {
		this.isMviEnabled = isMviEnabled;
	}

	public String getMviWsdlUrl() {
		return mviWsdlUrl;
	}

	public void setMviWsdlUrl(String mviWsdlUrl) {
		this.mviWsdlUrl = mviWsdlUrl;
	}

	public Integer getMviConnectTimeout() {
		return mviConnectTimeout;
	}

	public void setMviConnectTimeout(Integer mviConnectTimeout) {
		this.mviConnectTimeout = mviConnectTimeout;
	}

	public Integer getMviRequestTimeout() {
		return mviRequestTimeout;
	}

	public void setMviRequestTimeout(Integer mviRequestTimeout) {
		this.mviRequestTimeout = mviRequestTimeout;
	}

	public String getMviEnvType() {
		return mviEnvType;
	}

	public void setMviEnvType(String mviEnvType) {
		this.mviEnvType = mviEnvType;
	}

	public Boolean getIsMviMockSearchEnabled() {
		return isMviMockSearchEnabled;
	}

	public void setIsMviMockSearchEnabled(Boolean isMviMockSearchEnabled) {
		this.isMviMockSearchEnabled = isMviMockSearchEnabled;
	}

	public Boolean getIsMviMockCorrespondingEnabled() {
		return isMviMockCorrespondingEnabled;
	}

	public void setIsMviMockCorrespondingEnabled(Boolean isMviMockCorrespondingEnabled) {
		this.isMviMockCorrespondingEnabled = isMviMockCorrespondingEnabled;
	}

	public Boolean getIsMviMockCorrelationEnabled() {
		return isMviMockCorrelationEnabled;
	}

	public void setIsMviMockCorrelationEnabled(Boolean isMviMockCorrelationEnabled) {
		this.isMviMockCorrelationEnabled = isMviMockCorrelationEnabled;
	}

	public String getMviInteractionId() {
		return mviInteractionId;
	}

	public void setMviInteractionId(String mviInteractionId) {
		this.mviInteractionId = mviInteractionId;
	}

	public String getVaOidValue() {
		return vaOidValue;
	}

	public void setVaOidValue(String vaOidValue) {
		this.vaOidValue = vaOidValue;
	}

	public String getMviRootId() {
		return mviRootId;
	}

	public void setMviRootId(String mviRootId) {
		this.mviRootId = mviRootId;
	}

	public String getMviReceivingFacilityId() {
		return mviReceivingFacilityId;
	}

	public void setMviReceivingFacilityId(String mviReceivingFacilityId) {
		this.mviReceivingFacilityId = mviReceivingFacilityId;
	}

	public String getMviUsssaIdentifierId() {
		return mviUsssaIdentifierId;
	}

	public void setMviUsssaIdentifierId(String mviUsssaIdentifierId) {
		this.mviUsssaIdentifierId = mviUsssaIdentifierId;
	}

	public String getMviFacilityAssignAuthority() {
		return mviFacilityAssignAuthority;
	}

	public void setMviFacilityAssignAuthority(String mviFacilityAssignAuthority) {
		this.mviFacilityAssignAuthority = mviFacilityAssignAuthority;
	}

	public String getMviPatientIdentifier() {
		return mviPatientIdentifier;
	}

	public void setMviPatientIdentifier(String mviPatientIdentifier) {
		this.mviPatientIdentifier = mviPatientIdentifier;
	}

	public String getMviNationalIdentifier() {
		return mviNationalIdentifier;
	}

	public void setMviNationalIdentifier(String mviNationalIdentifier) {
		this.mviNationalIdentifier = mviNationalIdentifier;
	}
	
	public String getMviProdDodrootId() {
		return mviProdDodrootId;
	}

	public void setMviProdDodrootId(String mviProdDodrootId) {
		this.mviProdDodrootId = mviProdDodrootId;
	}

	public String getMviNonprodDodrootId() {
		return mviNonprodDodrootId;
	}

	public void setMviNonprodDodrootId(String mviNonprodDodrootId) {
		this.mviNonprodDodrootId = mviNonprodDodrootId;
	}

	public int getMviFacilitiesUpdateMaxCount() {
		return mviFacilitiesUpdateMaxCount;
	}

	public void setMviFacilitiesUpdateMaxCount(int mviFacilitiesUpdateMaxCount) {
		this.mviFacilitiesUpdateMaxCount = mviFacilitiesUpdateMaxCount;
	}
	

	public void setSmtpHost(String smtpHost) {
		this.smtpHost = smtpHost;
	}

	public String getSmtpHost() {
		return smtpHost;
	}
	
	public void setSmtpDebug(Boolean smtpDebug) {
		this.smtpDebug = smtpDebug;
	}

	public Boolean getSmtpDebug() {
		return smtpDebug;
	}
	  

}
