package gov.va.med.mhv.admin.web.controller;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.portlet.PortletRequest;
import javax.portlet.PortletSession;
import com.liferay.portal.util.PortalUtil;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.RequestScoped;
import javax.faces.context.FacesContext;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.apache.commons.lang.StringUtils;

import gov.va.med.mhv.admin.dto.SMSUserViewDTO;
import gov.va.med.mhv.admin.enums.AuthenticationStatusEnumeration;
import gov.va.med.mhv.admin.service.mhvusers.FacilityInfoService;
import gov.va.med.mhv.admin.service.mhvusers.InPersonAuthenticationService;
import gov.va.med.mhv.admin.service.mhvusers.PatientService;
import gov.va.med.mhv.admin.service.mhvusers.UserProfileService;
import gov.va.med.mhv.admin.web.formbean.SearchUserIPAFormBean;
import gov.va.med.mhv.admin.web.formbean.SearchUserIPAResultsFormBean;
import gov.va.med.mhv.admin.web.formbean.UserProfileFormBean;
import gov.va.med.mhv.admin.web.util.PasswordHintQuestionsEnumeration;
import gov.va.med.mhv.admin.web.util.PatientCorrelationStatus;
import gov.va.med.mhv.admin.web.util.SessionUtil;
import gov.va.med.mhv.common.api.dto.FacilityDTO;
import gov.va.med.mhv.common.api.dto.FacilityInfoDTO;
import gov.va.med.mhv.common.api.dto.InPersonAuthenticationDTO;
import gov.va.med.mhv.common.api.dto.PatientDTO;
import gov.va.med.mhv.common.api.dto.UserProfileDTO;
import gov.va.med.mhv.common.api.exception.MHVException;
import gov.va.med.mhv.common.api.util.ResponseUtil;
import gov.va.med.mhv.admin.dto.InPersonAuthenticationCriteriaDTO;
import gov.va.med.mhv.admin.dto.InPersonAuthenticationSearchResultDTO;

@ManagedBean(name = "inPersonAuthenticatonController")
@RequestScoped
//ViewScoped
public class InPersonAuthenticatonController {

	@SuppressWarnings("unused")
	private static final long serialVersionUID = -1947472689045056321L;

	private static final Logger LOG = LogManager.getLogger(InPersonAuthenticatonController.class);
	protected static final String ERR_PRCS_RQST = "Error Processing request";

	@ManagedProperty(value = "#{searchUserIPA}")
	SearchUserIPAFormBean searchUserIPAForm;

	@ManagedProperty(value = "#{searchIPAResults}")
	SearchUserIPAResultsFormBean searchIPAResults;

	@ManagedProperty(value = "#{userProfileInfo}")
	UserProfileFormBean userProfileInfo;

	@ManagedProperty(value = "#{sessionUtil}")
	SessionUtil sessionUtil;

	@ManagedProperty(value = "#{inPersonAuthenticationProxy}")
	private InPersonAuthenticationService inPersonAuthenticationProxy;

	@ManagedProperty(value = "#{patientProxy}")
	private PatientService patientProxy;

	@ManagedProperty(value = "#{userProfileProxy}")
	private UserProfileService userProfileProxy;

	@ManagedProperty(value = "#{facilityInfoProxy}")
	private FacilityInfoService facilityInfoProxy;

	private static final String TIME_FORMAT = "MM/dd/yyyy";

	public String searchUserIPA() {
		System.out.println(">>>> InPersonAuthenticatonController - searchUserIPA - Enter:");
		InPersonAuthenticationCriteriaDTO criteriaDTO = new InPersonAuthenticationCriteriaDTO();
		copyFromIPACriteriaFormToCriteria(criteriaDTO);
		return findUserIPA(criteriaDTO);
	}

	public String refreshUserIPA() {
		System.out.println(">>>> InPersonAuthenticatonController - refreshUserIPA - Enter:");
		if (userProfileInfo.getCurrentSearchCriteriaDTO() != null) {
			System.out.println(">>>> InPersonAuthenticatonController - refreshUserIPA - currentSearchCriteriaDTO is not null:");
			return findUserIPA(userProfileInfo.getCurrentSearchCriteriaDTO());
		}
		else {
			return "search?faces-redirect=true";
		}
	}

	public String findUserIPA(InPersonAuthenticationCriteriaDTO criteriaDTO) {
		System.out.println(">>>> InPersonAuthenticatonController - findUserIPA - Enter:");
		try {
			userProfileInfo.setCurrentSearchCriteriaDTO(criteriaDTO);

			List<PatientDTO> srp = new ArrayList<PatientDTO>();
			List<InPersonAuthenticationSearchResultDTO> iDTOList = new ArrayList<InPersonAuthenticationSearchResultDTO>();

			String lastName = null;
			String ssn = null;
			if (criteriaDTO.getFirstPlusFour() != null && criteriaDTO.getFirstPlusFour().length() > 0) {
				lastName = criteriaDTO.getFirstPlusFour().substring(0, 1);
				ssn = criteriaDTO.getFirstPlusFour().substring(1);
			} else {
				lastName = criteriaDTO.getLastName();
				ssn = criteriaDTO.getSsn();
			}

			System.out.println(">>>> InPersonAuthenticatonController - findUserIPA - firstName:" + criteriaDTO.getFirstName());

			UserProfileDTO uProfileDTO = new UserProfileDTO();
			uProfileDTO.setFirstName(criteriaDTO.getFirstName());
			uProfileDTO.setMiddleName(criteriaDTO.getMiddleName());
			uProfileDTO.setLastName(lastName);
			uProfileDTO.setConfEmail(criteriaDTO.getEmail());
			uProfileDTO.setUserName(criteriaDTO.getUserName());
			uProfileDTO.setMhvId(criteriaDTO.getMhvId());
			uProfileDTO.setSsn(ssn);
			uProfileDTO.setBirthDate(criteriaDTO.getDateOfBirth());
			System.out.println(">>>> InPersonAuthenticatonController - findUserIPA - Calling userProfileService with uProfileDTO.setFirstName:" + uProfileDTO.getFirstName());

			System.out.println(">>>> InPersonAuthenticatonController - findUserIPA - getStatusMatched:" + criteriaDTO.getStatusMatched());
			System.out.println(">>>> InPersonAuthenticatonController - findUserIPA - getStatusUnmatched:" + criteriaDTO.getStatusUnmatched());

			List<UserProfileDTO> uProfiles = userProfileProxy.searchUserIPAExtended(uProfileDTO);
			System.out.println(">>>> InPersonAuthenticatonController - findUserIPA - uProfiles size: "+uProfiles.size());
			if (uProfiles == null || uProfiles.size() == 0) {
				System.out.println(">>>> InPersonAuthenticatonController - findUserIPA - uProfiles is null");
				FacesContext context = FacesContext.getCurrentInstance();
				FacesContext.getCurrentInstance().addMessage(null,new FacesMessage(FacesMessage.SEVERITY_INFO, "There were no results found. Please try your search again.", "There were no results found. Please try your search again."));
				context.getApplication().getNavigationHandler().handleNavigation(context, null, "search.xhtml");
				return null;
			}
			searchIPAResults.setUserprofiles(uProfiles);
			if (uProfiles.size() > 0) {
				for (Iterator itr = uProfiles.iterator(); itr.hasNext();) {
					UserProfileDTO uprofile = (UserProfileDTO) itr.next();
					PatientDTO pDTO = getPatient(uprofile.getId());
					srp.add(pDTO);
					searchIPAResults.setPatients(srp);
					if (pDTO != null && pDTO.getUserProfile() != null) {
						iDTOList.add(getipaSearchResultDTO(pDTO));
						searchIPAResults.setIpaSearchResult(iDTOList);
					}
				}
			}
			if (searchIPAResults != null) {
				return "searchResults?faces-redirect=true";
			}
		} catch (MHVException e) {
			FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, e.getFailureMessage(), "Error in Searching for IPA Users."));
			return "search?faces-redirect=true";
		} catch (Exception e) {
			LOG.error("Error in Searchuser() : ", e);
			return "search?faces-redirect=true";
		}
		FacesContext context = FacesContext.getCurrentInstance();
		context.getApplication().getNavigationHandler().handleNavigation(context, null, "searchResults.xhtml");
		return null;
		//return "searchResults?faces-redirect=true";
	}

	public String basicRefresh() {
		System.out.println(">>>> InPersonAuthenticatonController - basicRefresh - Enter:");
		if (userProfileInfo.getCurrentSearchCriteriaDTO() != null) {
			System.out.println(">>>> InPersonAuthenticatonController - basicRefresh - currentSearchCriteriaDTO is not null:");
			return basicFind(userProfileInfo.getCurrentSearchCriteriaDTO());
		}
		else {
			return "basicSearch?faces-redirect=true";
		}
	}

	public String basicSearch() {
		System.out.println(">>>> InPersonAuthenticatonController - basicSearch - Enter:");
		InPersonAuthenticationCriteriaDTO criteriaDTO = new InPersonAuthenticationCriteriaDTO();
		copyFromIPABasicCriteriaFormToCriteria(criteriaDTO);
		return basicFind(criteriaDTO);
	}

	public String basicFind(InPersonAuthenticationCriteriaDTO criteriaDTO) {
		System.out.println(">>>> InPersonAuthenticatonController - basicFind - Enter:");
		try {
			userProfileInfo.setCurrentSearchCriteriaDTO(criteriaDTO);

			List<PatientDTO> srp = new ArrayList<PatientDTO>();

			// MHV_CodeCR1387 - Added last name and ssn in the search
			String lastName = null;
			String ssn = null;
			if (criteriaDTO.getFirstPlusFour() != null && criteriaDTO.getFirstPlusFour().length() > 0) {

				String firstPlusFour = criteriaDTO.getFirstPlusFour();
				lastName = criteriaDTO.getFirstPlusFour().substring(0, 1);
				ssn = criteriaDTO.getFirstPlusFour().substring(1);
			} else {
				lastName = criteriaDTO.getLastName();
				ssn = criteriaDTO.getSsn();
			}

			System.out.println(">>>> InPersonAuthenticatonController - basicFind - firstName:"+ criteriaDTO.getFirstName());

			UserProfileDTO uProfileDTO = new UserProfileDTO();
			uProfileDTO.setFirstName(criteriaDTO.getFirstName());
			uProfileDTO.setMiddleName(criteriaDTO.getMiddleName());
			uProfileDTO.setLastName(lastName);
			uProfileDTO.setConfEmail(criteriaDTO.getEmail());
			uProfileDTO.setUserName(criteriaDTO.getUserName());
			uProfileDTO.setMhvId(criteriaDTO.getMhvId());
			uProfileDTO.setSsn(ssn);
			uProfileDTO.setBirthDate(criteriaDTO.getDateOfBirth());
			System.out.println(">>>> InPersonAuthenticatonController - basicFind - Calling userProfileService with uProfileDTO.setFirstName:" + uProfileDTO.getFirstName());
			List<UserProfileDTO> uProfiles = userProfileProxy.searchUserIPAExtended(uProfileDTO);
			System.out.println(">>>> InPersonAuthenticatonController - basicFind - uProfiles size: "+uProfiles.size());
			if (uProfiles == null || uProfiles.size() == 0) {
				System.out.println(">>>> InPersonAuthenticatonController - basicFind - uProfiles is null");
				FacesContext context = FacesContext.getCurrentInstance();
				FacesContext.getCurrentInstance().addMessage(null,new FacesMessage(FacesMessage.SEVERITY_INFO, "No users were found for the search criteria entered.", "No users were found for the search criteria entered."));
				context.getApplication().getNavigationHandler().handleNavigation(context, null, "basicSearch.xhtml");
				return null;
			}
			searchIPAResults.setUserprofiles(uProfiles);
			if (uProfiles.size() > 0) {
				for (Iterator itr = uProfiles.iterator(); itr.hasNext();) {
					UserProfileDTO uprofile = (UserProfileDTO) itr.next();
					PatientDTO pDTO = getPatient(uprofile.getId());
					if (pDTO != null && pDTO.getUserProfile() != null) {
						srp.add(pDTO);
						searchIPAResults.setPatients(srp);
					}
				}
			}
			if (searchIPAResults != null) {
				return "basicSearchResults?faces-redirect=true";
			}
		} catch (MHVException e) {
			FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR,
					e.getFailureMessage(), "Error in Searching for IPA Users."));
			return "basicSearch?faces-redirect=true";
		} catch (Exception e) {
			LOG.error("Error in Searchuser() : ", e);
			return "basicSearch?faces-redirect=true";
		}
		FacesContext context = FacesContext.getCurrentInstance();
		context.getApplication().getNavigationHandler().handleNavigation(context, null, "basicSearchResults.xhtml");
		return null;
		//return "basicSearchResults?faces-redirect=true";
	}


	private void copyFromIPACriteriaFormToCriteria(InPersonAuthenticationCriteriaDTO criteriaDTO) {
		copySsnToCriteria(criteriaDTO);
		copyFacilityToCriteria(criteriaDTO);
		copyTrimmedStringsToCriteria(criteriaDTO);
		copyIpaStatusToCriteria(criteriaDTO);
	}

	private void copyFromIPABasicCriteriaFormToCriteria(InPersonAuthenticationCriteriaDTO criteriaDTO) {
		copySsnToCriteria(criteriaDTO);
		copyFacilityToCriteria(criteriaDTO);
		copyTrimmedStringsToCriteria(criteriaDTO);
	}

	public void copySsnToCriteria(InPersonAuthenticationCriteriaDTO criteriaDTO) {
		String ssn = getFormattedSsn();
		if (!StringUtils.isBlank(ssn)){
			criteriaDTO.setSsn(ssn.toString());
		} else {
			criteriaDTO.setSsn(null);
		}
	}

	public String getFormattedSsn(){
		if (!StringUtils.isBlank(searchUserIPAForm.getSsn3()) && !StringUtils.isBlank(searchUserIPAForm.getSsn2())
            && !StringUtils.isBlank(searchUserIPAForm.getSsn4()))
        {
			StringBuffer ssn = new StringBuffer(11);
			ssn.append(searchUserIPAForm.getSsn3());
			ssn.append("-");
			ssn.append(searchUserIPAForm.getSsn2());
			ssn.append("-");
			ssn.append(searchUserIPAForm.getSsn4());
			return ssn.toString();
		}
		return "";
	}

	public void copyFacilityToCriteria(InPersonAuthenticationCriteriaDTO criteriaDTO)
	    {
			String authFacility = searchUserIPAForm.getAuthenticatingFacility();
			String treatFacility = searchUserIPAForm.getTreatingFacility();

			if (!StringUtils.isBlank(authFacility)) {
				criteriaDTO.setAuthenticatingFacilityInfoId(Long.parseLong(authFacility));
			} else {
				criteriaDTO.setAuthenticatingFacilityInfoId(null);
			}

			if (!StringUtils.isBlank(treatFacility)) {
				criteriaDTO.setTreatingFacilityId(Long.parseLong(treatFacility));
			} else {
				criteriaDTO.setTreatingFacilityId(null);
			}
		}

	public void copyTrimmedStringsToCriteria(InPersonAuthenticationCriteriaDTO criteriaDTO)
	    {
			if (searchUserIPAForm.getFirstName() !=null){
				criteriaDTO.setFirstName(searchUserIPAForm.getFirstName().trim());
			}
			if (searchUserIPAForm.getLastName() !=null){
				criteriaDTO.setLastName(searchUserIPAForm.getLastName().trim());
			}
			if (searchUserIPAForm.getMiddleName() !=null){
				criteriaDTO.setMiddleName(searchUserIPAForm.getMiddleName().trim());
			}
			if (searchUserIPAForm.getEmail() !=null){
				criteriaDTO.setEmail(searchUserIPAForm.getEmail().trim());
			}
			if (searchUserIPAForm.getFirstPlusFour() !=null){
				criteriaDTO.setFirstPlusFour(searchUserIPAForm.getFirstPlusFour().trim());
			}
			if (searchUserIPAForm.getMhvId() !=null){
				criteriaDTO.setMhvId(searchUserIPAForm.getMhvId().trim());
			}
			if (searchUserIPAForm.getUserName() !=null){
				criteriaDTO.setUserName(searchUserIPAForm.getUserName().trim());
			}
			if (searchUserIPAForm.getBirthDate() !=null){
				criteriaDTO.setDateOfBirth(searchUserIPAForm.getBirthDate());
			}
		}

	public void copyIpaStatusToCriteria(InPersonAuthenticationCriteriaDTO criteriaDTO)
    {
		criteriaDTO.setStatusMatched(searchUserIPAForm.isIpaStatusMatched());
		criteriaDTO.setStatusUnmatched(searchUserIPAForm.isIpaStatusUnmatched());
		criteriaDTO.setStatusCorrelated(searchUserIPAForm.isIpaStatusCorrelated());
		criteriaDTO.setStatusUncorrelated(searchUserIPAForm.isIpaStatusUncorrelated());
		criteriaDTO.setStatusPendingCorrelation(searchUserIPAForm.isIpaStatusPendingCorrelation());
		criteriaDTO.setStatusPendingUncorrelated(searchUserIPAForm.isIpaStatusPendingUncorrelated());
		criteriaDTO.setStatusFailedCorrelation(searchUserIPAForm.isIpaStatusFailedCorrelation());
		criteriaDTO.setStatusFailedUncorrelation(searchUserIPAForm.isIpaStatusFailedUncorrelation());
		criteriaDTO.setStatusCorrelationInvalid(searchUserIPAForm.isIpaStatusCorrelationInvalid());
		criteriaDTO.setStatusAuthenticated(searchUserIPAForm.isIpaStatusAuthenticated());
		criteriaDTO.setStatusPrerequisitesComplete(searchUserIPAForm.isIpaStatusPrerequisitesComplete());
		criteriaDTO.setStatusInProcess(searchUserIPAForm.isIpaStatusInProcess());
		criteriaDTO.setStatusUnauthenticated(searchUserIPAForm.isIpaStatusUnauthenticated());
		criteriaDTO.setStatusPendingDataMismatch(searchUserIPAForm.isIpaStatusPendingDataMismatch());
		criteriaDTO.setStatusPendingUnauthentication(searchUserIPAForm.isIpaStatusPendingUnauthentication());
	}


	public String launchBasicSearch() {
		InPersonAuthenticationDTO ipaResponse = null;
		try {
			PatientDTO patient = getPatient(userProfileInfo.getSelectedProfile().getId());
			System.out.println(">>>> InPersonAuthenticatonController - launchBasicSearch - ICN:" + patient.getIcn());
			System.out.println(">>>> InPersonAuthenticatonController - launchBasicSearch - View All Accounts page displayed successfully.");
		} catch (Exception e) {
			LOG.error("Error in Reset of Search Screen.", e);
		}
		return "basicSearch?faces-redirect=true";
	}


	public String resetBasicSearchIPA() {
		InPersonAuthenticationDTO ipaResponse = null;
		try {
			PatientDTO patient = getPatient(userProfileInfo.getSelectedProfile().getId());
			System.out.println(">>>> InPersonAuthenticatonController - resetBasicSearchIPA - ICN:" + patient.getIcn());
			System.out.println(">>>> InPersonAuthenticatonController - resetBasicSearchIPA - View All Accounts page displayed successfully.");
		} catch (Exception e) {
			LOG.error("Error in Reset of Basic Search Screen.", e);
		}
		return "basicSearch?faces-redirect=true";
	}

	public String cancelBasicSearchIPA() {
		InPersonAuthenticationDTO ipaResponse = null;
		try {
			PatientDTO patient = getPatient(userProfileInfo.getSelectedProfile().getId());
			System.out.println(">>>> InPersonAuthenticatonController - cancelBasicSearchIPA - ICN:" + patient.getIcn());
			System.out.println(">>>> InPersonAuthenticatonController - cancelBasicSearchIPA - View All Accounts page displayed successfully.");
		} catch (Exception e) {
			LOG.error("Error in cancel of Basic Search Screen.", e);
		}
		return "search?faces-redirect=true";
	}


	public String performBasicSearchDetail() {
		String userIdStr = FacesContext.getCurrentInstance().getExternalContext().getRequestParameterMap().get("userProfileId");

		PatientDTO patient = null;
		InPersonAuthenticationDTO ipa = null;

		System.out.println(">>>> InPersonAuthenticatonController - performBasicSearchDetail - userIdStr:" + userIdStr);
		Long userProfileId = Long.parseLong(userIdStr);
		System.out.println(">>>> InPersonAuthenticatonController - performBasicSearchDetail - userProfileId:" + userProfileId);

		try {
			userProfileInfo.setSelectedProfile(userProfileProxy.findUserProfileById(userProfileId));
			System.out.println(">>>> InPersonAuthenticatonController - performBasicSearchDetail - selectedProfile getMhvId:" + userProfileInfo.getSelectedProfile().getMhvId());

			patient = getPatient(userProfileInfo.getSelectedProfile().getId());
			ipa = getIPAPatientById(patient);
			userProfileInfo.setSelectedPatient(patient);
			userProfileInfo.setSelectedIPA(ipa);

			populateSelectedUserFields(userProfileInfo.getSelectedProfile(), patient, ipa);
			System.out.println(">>>> InPersonAuthenticatonController - performBasicSearchDetail - Completed populateSelectedUserFields");
		} catch (MHVException e) {
			FacesContext.getCurrentInstance().addMessage(null,
					new FacesMessage(FacesMessage.SEVERITY_ERROR, e.getFailureMessage(), null));
			LOG.error("Error in performAuthentication:", e);
		}

		return "basicSearchDetail?faces-redirect=true";

	}


/*
        @Jpf.Forward(name = AuthenticationStatus.UNAUTHENTICATED, action="initiateAuthentication"),
        @Jpf.Forward(name = AuthenticationStatus.PENDINGAUTHENTICATION, action="initiateAuthentication"),
        @Jpf.Forward(name = AuthenticationStatus.PENDINGFAILED, action="continueAuthentication"),
        @Jpf.Forward(name = AuthenticationStatus.PENDINGDATAMISMATCH, action="continueAuthentication"),
        @Jpf.Forward(name = AuthenticationStatus.INPROCESS, action="continueAuthentication"),
		@Jpf.Forward(name = AuthenticationStatus.PREREQUISITESCOMPLETE, action="continueAuthentication"),
        @Jpf.Forward(name = AuthenticationStatus.AUTHENTICATED, action = "removeAuthentication"),
        @Jpf.Forward(name = AuthenticationStatus.PENDINGREMOVAL, action = "initiateAuthentication"),
		@Jpf.Forward(name = "failure", navigateTo = Jpf.NavigateTo.currentPage)}

		In legacy initiateAuthentication and continueAuthentication has the same code.
*/
	public String performAuthentication() {
		String userIdStr = FacesContext.getCurrentInstance().getExternalContext().getRequestParameterMap().get("userProfileId");

		if (userIdStr == null || StringUtils.isBlank(userIdStr))
			userIdStr = userProfileInfo.getSelectedProfileIdForReset();	// IN case of reset, retrieve from bean
		else
			userProfileInfo.setSelectedProfileIdForReset(userIdStr);

		PatientDTO patient = null;
		InPersonAuthenticationDTO ipa = null;

		System.out.println(">>>> InPersonAuthenticatonController - performAuthentication - userIdStr:" + userIdStr);
		Long userProfileId = Long.parseLong(userIdStr);
		System.out.println(">>>> InPersonAuthenticatonController - performAuthentication - userProfileId:" + userProfileId);

		try {
			userProfileInfo.setSelectedProfile(userProfileProxy.findUserProfileById(userProfileId));
			System.out.println(">>>> InPersonAuthenticatonController - performAuthentication - selectedProfile getMhvId:" + userProfileInfo.getSelectedProfile().getMhvId());

			patient = getPatient(userProfileInfo.getSelectedProfile().getId());
			System.out.println(">>>> InPersonAuthenticatonController - performAuthentication - patient - id:"+ patient.getId());
			ipa = getIPAPatientById(patient);
			userProfileInfo.setSelectedPatient(patient);
			userProfileInfo.setSelectedIPA(ipa);
			if (ipa != null && ipa.getAuthenticatingFacilityId() != null) {
				searchUserIPAForm.setAuthenticatingFacility(Long.toString(ipa.getAuthenticatingFacilityId()));
				System.out.println(">>>> InPersonAuthenticatonController - performAuthentication - setSelectedIPA - id:"+ ipa.getId()+" -- AuthenticatingFacilityId:"+ipa.getAuthenticatingFacilityId()+" -- AuthenticatingFacility:"+ipa.getAuthenticatingFacilityDTO().getName());				
			}
			if (StringUtils.isBlank(searchUserIPAForm.getAuthenticatingFacility())) {
				userProfileInfo.setRenderAuthenticatingFacility(true);
				System.out.println(">>>> InPersonAuthenticatonController - setRenderAuthenticatingFacility set to true");
			}
			else {
				userProfileInfo.setRenderAuthenticatingFacility(false);
				System.out.println(">>>> InPersonAuthenticatonController - setRenderAuthenticatingFacility set to false");
			}
			

			populateSelectedUserFields(userProfileInfo.getSelectedProfile(), patient, ipa);
			System.out.println(">>>> InPersonAuthenticatonController - performAuthentication - Completed populateSelectedUserFields");
		} catch (MHVException e) {
			FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, e.getFailureMessage(), null));
			LOG.error("Error in performAuthentication:", e);
		}

		if (ipa != null && ipa.getStatus().equalsIgnoreCase(AuthenticationStatusEnumeration.AUTHENTICATED.getDescription()))
		{
			FacesContext context = FacesContext.getCurrentInstance();
			context.getApplication().getNavigationHandler().handleNavigation(context, null, "removeAuthentication.xhtml");
			return null;			
			//return "removeAuthentication?faces-redirect=true";
		} else {
			FacesContext context = FacesContext.getCurrentInstance();
			context.getApplication().getNavigationHandler().handleNavigation(context, null, "authenticatePatient.xhtml");
			return null;
			//return "authenticatePatient?faces-redirect=true";
		}

	}

	public String reloadPerformAuthentication(Long userProfileId) {
		PatientDTO patient = null;
		InPersonAuthenticationDTO ipa = null;

		System.out.println(">>>> InPersonAuthenticatonController - reloadPerformAuthentication - userProfileId:" + userProfileId);

		try {
			userProfileInfo.setSelectedProfile(userProfileProxy.findUserProfileById(userProfileId));
			System.out.println(">>>> InPersonAuthenticatonController - reloadPerformAuthentication - selectedProfile getMhvId:"
					+ userProfileInfo.getSelectedProfile().getMhvId());

			patient = getPatient(userProfileInfo.getSelectedProfile().getId());
			ipa = getIPAPatientById(patient);
			userProfileInfo.setSelectedPatient(patient);
			userProfileInfo.setSelectedIPA(ipa);
			searchUserIPAForm.setAuthenticatingFacility(Long.toString(ipa.getAuthenticatingFacilityId()));
			if (StringUtils.isBlank(searchUserIPAForm.getAuthenticatingFacility()))
				userProfileInfo.setRenderAuthenticatingFacility(true);
			else
				userProfileInfo.setRenderAuthenticatingFacility(false);

			populateSelectedUserFields(userProfileInfo.getSelectedProfile(), patient, ipa);
			System.out.println(">>>> InPersonAuthenticatonController - reloadPerformAuthentication - Completed populateSelectedUserFields");
		} catch (MHVException e) {
			FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, e.getFailureMessage(), null));
			LOG.error("Error in reloadPerformAuthentication:", e);
		}

		if (ipa != null && ipa.getStatus().equalsIgnoreCase(AuthenticationStatusEnumeration.AUTHENTICATED.getDescription()))
		{
			return "removeAuthentication?faces-redirect=true";
		} else {
			return "authenticatePatient?faces-redirect=true";
		}

	}

	private void populateSelectedUserFields(UserProfileDTO selectedProfile, PatientDTO patient, InPersonAuthenticationDTO ipa) {

		// JAZZ # 139480: Federated Credential - Admin Portal - Frontend Changes
		if (userProfileInfo.getSelectedProfile() != null) {
			System.out.println(">>>> InPersonAuthenticatonController - populateSelectedUserFields - userProfileInfo.getSelectedProfile() is not null.");
			userProfileInfo.setSignInPartners(userProfileInfo.getSelectedProfile().getSignInPartners());
		}

		if (!userProfileInfo.getSelectedProfile().getRestrictSIPAccess()) {
			userProfileInfo.setDisplayRestrictSipButton(true);
		} else {
			userProfileInfo.setDisplayRestrictSipButton(false);
		}

		///
		int q1 = userProfileInfo.getSelectedProfile().getPasswordHintQuestion1() != null ? userProfileInfo.getSelectedProfile().getPasswordHintQuestion1() : 0;
		int q2 = userProfileInfo.getSelectedProfile().getPasswordHintQuestion2() != null ? userProfileInfo.getSelectedProfile().getPasswordHintQuestion1() : 0;

		for (PasswordHintQuestionsEnumeration s : PasswordHintQuestionsEnumeration.values()) {
			if (s.getValue() == q1) {
				userProfileInfo.setPasswordHintQuestion1(s.getDescription());
			}
			if (s.getValue() == q2) {
				userProfileInfo.setPasswordHintQuestion2(s.getDescription());

			}
		}
		System.out.println(">>>> InPersonAuthenticatonController - populateSelectedUserFields - getSignInPartners"
				+ userProfileInfo.getSignInPartners());

		if (userProfileInfo.getSelectedProfile().getCurrentLogin() != null) {
			userProfileInfo.getSelectedProfile().setLastLogin(selectedProfile.getCurrentLogin());
		}

		SMSUserViewDTO sMSUserViewDTO = null;
		try {
			System.out.println(
					">>>> InPersonAuthenticatonController - populateSelectedUserFields - userProfileInfo.getSelectedProfile().getUserName()"
							+ userProfileInfo.getSelectedProfile().getUserName());
			sMSUserViewDTO = userProfileProxy.getSMUser(userProfileInfo.getSelectedProfile().getUserName());
		} catch (MHVException e) {
			FacesContext.getCurrentInstance().addMessage(null,
					new FacesMessage(FacesMessage.SEVERITY_ERROR, e.getFailureMessage(), null));
			LOG.error("Error in populateSelectedUserFields:", e);
		}
		if (sMSUserViewDTO != null) {
			System.out.println(
					">>>> InPersonAuthenticatonController - populateSelectedUserFields - sMSUserViewDTO.getCurrentLoginDate()"
							+ sMSUserViewDTO.getCurrentLoginDate());
			userProfileInfo.setLastSMLoginDateTime(sMSUserViewDTO.getCurrentLoginDate());
		}
		userProfileInfo.setRelationshipToVA(determineRelationshipToVA());
		userProfileInfo.setMatchingStatus("Unmatched");
		userProfileInfo.setMatchingDate(null);

		// Correlation fields
		updateCorrrelationFields(patient, ipa);

		// Account status
		determineAccountStatus(patient);

		// Terminate Authentication Button determination
		determineTerminateAuthButton(ipa);

		// Authenticate Button determination
		determineAuthenticationButton(patient, ipa);

		// Match Button determination
		determineMatchButton(patient, ipa);

		// Correlate Button determination
		determineCorrelateButton(patient, ipa);

	}

	private void determineCorrelateButton(PatientDTO patient, InPersonAuthenticationDTO ipa) {
		if ((patient.getCorrelationStatus() == 0 || // UNCORRELATED
				patient.getCorrelationStatus() == 7 || // MVIDATAMATCH
				patient.getCorrelationStatus() == 5 || // FAILEDCORRELATION
				patient.getCorrelationStatus() == 4 || // FAILEDUNCORRELATION
				patient.getCorrelationStatus() == 6) && // CORRELATIONINVALID
				(patient.getMatchedDateTime() != null) && !userProfileInfo.getDisplayMatchButton()) {
			userProfileInfo.setDisplayCorrelateButton(true);
		} else if ((ipa != null && ipa.getStatus()
				.equalsIgnoreCase(AuthenticationStatusEnumeration.PENDINGAUTHENTICATION.getDescription())
				&& (patient.getCorrelationStatus() == 1)) && !userProfileInfo.getDisplayMatchButton()) {
			userProfileInfo.setDisplayCorrelateButton(true);
		} else {
			userProfileInfo.setDisplayCorrelateButton(false);
		}
	}

	private void determineMatchButton(PatientDTO patient, InPersonAuthenticationDTO ipa) {
		userProfileInfo.setDisplayMatchButton(false);
		if (ipa != null) {
			if ((ipa.getStatus().equalsIgnoreCase(AuthenticationStatusEnumeration.PENDINGDATAMISMATCH.getDescription())
					|| ipa.getStatus().equalsIgnoreCase(AuthenticationStatusEnumeration.INPROCESS.getDescription())
					|| ipa.getStatus()
							.equalsIgnoreCase(AuthenticationStatusEnumeration.PREREQUISITESCOMPLETE.getDescription())
					|| ipa.getStatus().equalsIgnoreCase(AuthenticationStatusEnumeration.UNAUTHENTICATED.getDescription())
					|| ipa.getStatus().equalsIgnoreCase(AuthenticationStatusEnumeration.PENDINGREMOVAL.getDescription()))
					&& (patient.getMatchedDateTime() == null) && (patient.getCorrelationStatus() == 2)) {
				userProfileInfo.setDisplayMatchButton(true);
			} else if ((patient.getCorrelationStatus() == 0 || // UNCORRELATED
					patient.getCorrelationStatus() == 5 || // FAILEDCORRELATION
					patient.getCorrelationStatus() == 4 || // FAILEDUNCORRELATION
					patient.getCorrelationStatus() == 6) // CORRELATIONINVALID
			) {
				userProfileInfo.setDisplayMatchButton(true);
			} else if ((patient.getCorrelationStatus() == 1 || // PENDINGCORRELATION
					patient.getCorrelationStatus() == 3)) { // PENDINGUNCORRELATION
				userProfileInfo.setDisplayMatchButton(true);
			}
		}
	}

	private void determineAuthenticationButton(PatientDTO patient, InPersonAuthenticationDTO ipa) {
		System.out.println(">>>> InPersonAuthenticatonController - determineAuthenticationButton - Entered:");
		if (null != ipa && null != patient) {
			System.out
					.println(">>>> InPersonAuthenticatonController - determineAuthenticationButton - patient-Id:/ipaId:"
							+ patient.getId() + "/" + ipa.getId());
			System.out.println(">>>> InPersonAuthenticatonController - determineAuthenticationButton - patient.getCorrelationStatus():"
					+ patient.getCorrelationStatus());
			System.out.println(">>>> InPersonAuthenticatonController - determineAuthenticationButton - PatientCorrelationStatus.CORRELATED:"
					+ PatientCorrelationStatus.CORRELATED);
			System.out.println(">>>> InPersonAuthenticatonController - determineAuthenticationButton - ipa.getStatus():"
					+ ipa.getStatus());
			System.out.println(">>>> InPersonAuthenticatonController - determineAuthenticationButton - AuthenticationStatusEnumeration.AUTHENTICATED.getDescription():"
					+ AuthenticationStatusEnumeration.AUTHENTICATED.getDescription());
			System.out.println(">>>> InPersonAuthenticatonController - determineAuthenticationButton - AuthenticationStatusEnumeration.PENDINGAUTHENTICATION.getDescription():"
					+ AuthenticationStatusEnumeration.PENDINGAUTHENTICATION.getDescription());

			if ((patient.getCorrelationStatus() == 2)
					&& (null != patient.getMatchedDateTime())
					&& (!ipa.getStatus()
							.equalsIgnoreCase(AuthenticationStatusEnumeration.AUTHENTICATED.getDescription()))
					&& (!ipa.getStatus()
							.equalsIgnoreCase(AuthenticationStatusEnumeration.PENDINGAUTHENTICATION.getDescription()))) {
				userProfileInfo.setDisplayAuthButton(true);
				System.out.println(">>>> InPersonAuthenticatonController - determineAuthenticationButton - DisplayAuthButton set to TRUE:");
			} else {
				userProfileInfo.setDisplayAuthButton(false);
				System.out.println(">>>> InPersonAuthenticatonController - determineAuthenticationButton - DisplayAuthButton set to FALSE:");
			}
		} else {
			userProfileInfo.setDisplayAuthButton(false);
			System.out.println(">>>> InPersonAuthenticatonController - determineAuthenticationButton - DisplayAuthButton set to FALSE-1:");
		}

	}

	// Retrieve IPA DTO
	private InPersonAuthenticationDTO getIPAPatientById(PatientDTO patient) {
		InPersonAuthenticationDTO ipa = null;
		try {
			if (patient != null) {
				System.out.println(">>>> InPersonAuthenticatonController - getIPAPatientById");
				ipa = inPersonAuthenticationProxy.getIPAPatientById(patient.getId());
				if (ipa == null)
					System.out.println(">>>> InPersonAuthenticatonController - getIPAPatientById - ipa is null");
			}
		} catch (Exception ex) {
			LOG.error("Error receiving IPA from the backend service" + ex);
		}

		return ipa;
	}

	private String determineRelationshipToVA() {
		StringBuffer relationshipToVA = new StringBuffer("");
		if (userProfileInfo.getSelectedProfile().getIsPatient()) {
			relationshipToVA.append("VA Patient");
		}

		if (userProfileInfo.getSelectedProfile().getIsVeteran()) {
			if (relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("Veteran");
		}

		if (userProfileInfo.getSelectedProfile().getIsHealthCareProvider()) {
			if (relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("Health Care Provider");
		}

		if (userProfileInfo.getSelectedProfile().getIsPatientAdvocate()) {
			if (relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("Veteran Advocate/Family Member/Friend");
		}

		if (userProfileInfo.getSelectedProfile().getIsEmployee()) {
			if (relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("VA Employee");
		}

		if (userProfileInfo.getSelectedProfile().getIsOther()) {
			if (relationshipToVA.length() > 0) {
				relationshipToVA.append(", ");
			}
			relationshipToVA.append("Other");
		}

		System.out.println(">>>> InPersonAuthenticatonController - determineRelationshipToVA - status"
				+ relationshipToVA.toString());
		return relationshipToVA.toString();
	}

	private void determineAccountStatus(PatientDTO patient) {
		try {
			if (patient != null) {
				if (patient.getIcn() != null) {
					userProfileInfo.setIcn(patient.getIcn());
				} else {
					userProfileInfo.setIcn("");
				}

				if (patient.getMatchedDateTime() != null) {
					userProfileInfo.setMatchingStatus("Matched");
					userProfileInfo.setMatchingDate(patient.getMatchedDateTime());
				}

				Boolean isPatientAuthenticated = false;
				// InPersonAuthenticationService inPersonAuthenticationService =
				// (InPersonAuthenticationService) SpringContext
				// .getApplicationContext().getBean("inPersonAuthenticationProxy");

				isPatientAuthenticated = inPersonAuthenticationProxy.isPatientAuthenticated(patient.getId());
				System.out.println(
						">>>> InPersonAuthenticatonController - determineAccountStatus - isPatientAuthenticated 1"
								+ isPatientAuthenticated);
				if (userProfileInfo.getMatchingDate() == null) {
					userProfileInfo.setAccountStatus("Basic");
				} else if (isPatientAuthenticated) {
					System.out.println(
							">>>> InPersonAuthenticatonController - determineAccountStatus - isPatientAuthenticated 2"
									+ isPatientAuthenticated);
					if (isPatientAuthenticated
							&& userProfileInfo.getCorrelationStatus().equals(PatientCorrelationStatus.CORRELATED))
						userProfileInfo.setAccountStatus("Premium");
					else if (isPatientAuthenticated
							&& !userProfileInfo.getCorrelationStatus().equals(PatientCorrelationStatus.CORRELATED))
						userProfileInfo.setAccountStatus("Advanced");
					else if (!isPatientAuthenticated && userProfileInfo.getMatchingDate() != null)
						userProfileInfo.setAccountStatus("Advanced");
				} else {
					userProfileInfo.setAccountStatus("Advanced");
				}
			} else {
				userProfileInfo.setAccountStatus("Basic");
			}
		} catch (MHVException e) {
			FacesContext.getCurrentInstance().addMessage(null,
					new FacesMessage(FacesMessage.SEVERITY_ERROR, e.getFailureMessage(), null));
			LOG.error("Error in resetpassword", e);
			// e.printStackTrace();
		}

		System.out.println(">>>> InPersonAuthenticatonController - determineAccountStatus - status"
				+ userProfileInfo.getAccountStatus());
	}

	// Show or Hide Terminate Authentication Button
	private void determineTerminateAuthButton(InPersonAuthenticationDTO ipa){
		if(null!=ipa){
			if(null!= ipa.getStatus() && (ipa.getStatus().equalsIgnoreCase(AuthenticationStatusEnumeration.INPROCESS.getDescription()) ||
					ipa.getStatus().equalsIgnoreCase(AuthenticationStatusEnumeration.PREREQUISITESCOMPLETE.getDescription()))){
				userProfileInfo.setDisplayTerminateAuthButton(true);
			}else{
				userProfileInfo.setDisplayTerminateAuthButton(false);
			}
		}else{
			userProfileInfo.setDisplayTerminateAuthButton(false);
		}
	}

	private void updateCorrrelationFields(PatientDTO patient, InPersonAuthenticationDTO ipa) {
		try {
			if (patient != null) {
				System.out.println(
						">>>> InPersonAuthenticatonController - updateCorrrelationFields - updateCorrrelationFields");
				System.out.println(
						">>>> InPersonAuthenticatonController - updateCorrrelationFields - patient.getCorrelationStatus()"
								+ patient.getCorrelationStatus());
				if (patient.getCorrelationStatus() != null) {
					// userProfileInfo.setCorrelationStatus(patient.getCorrelationStatus());
					// Admin Portal_CodeCR1846 - Formatted the statuses.
					if (patient.getCorrelationStatus() == 0) {
						userProfileInfo.setCorrelationStatus("Uncorrelated");
					} else if (patient.getCorrelationStatus() == 1) {
						userProfileInfo.setCorrelationStatus("Pending Correlation");
					} else if (patient.getCorrelationStatus() == 3) {
						userProfileInfo.setCorrelationStatus("Pending Uncorrelation");
					} else if (patient.getCorrelationStatus() == 2) {
						userProfileInfo.setCorrelationStatus("Correlated");
					} else if (patient.getCorrelationStatus() == 6) {
						userProfileInfo.setCorrelationStatus("Correlation Invalid");
					} else if (patient.getCorrelationStatus() == 5) {
						userProfileInfo.setCorrelationStatus("Failed Correlation");
					} else if (patient.getCorrelationStatus() == 4) {
						userProfileInfo.setCorrelationStatus("Failed Uncorrelation");
					} else if (patient.getCorrelationStatus() == 7) {
						userProfileInfo.setCorrelationStatus("MviDataMatch");
					}
				} else {
					userProfileInfo.setCorrelationStatus("");
				}

				if (patient.getCorrelatedDateTime() != null) {
					userProfileInfo.setCorrelationDate(patient.getCorrelatedDateTime());
				} else {
					userProfileInfo.setCorrelationDate(null);
				}
				if (patient.getCorrelateRequestDateTime() != null) {
					userProfileInfo.setCorrelateRequestDate(patient.getCorrelateRequestDateTime());
				} else {
					userProfileInfo.setCorrelateRequestDate(null);
				}

				if (patient.getCorrelatedBy() != null) {
					userProfileInfo.setCorrelatedBy(patient.getCorrelatedBy());
				} else {
					userProfileInfo.setCorrelatedBy("");
				}

				// mviAuthenticationStatus = "";
				if (ipa != null && ipa.getMviAuthenticationStatus() != null) {
					if (ipa.getMviAuthenticationStatus().equals("OK")) {
						userProfileInfo.setMviAuthenticationStatus("Successful");
					} else if (ipa.getMviAuthenticationStatus().equals("PENDING_AUTH")) {
						userProfileInfo.setMviAuthenticationStatus("Authentication Unsuccessful");
					} else if (ipa.getMviAuthenticationStatus().equals("PENDING_UNAUTH")) {
						userProfileInfo.setMviAuthenticationStatus("Unauthentication Unsuccessful");
					}
				}
				//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Displaying new fields in Admin Portal IPA Search Detail Page
				userProfileInfo.setTreatingFacilities(getTxFacilities(patient));
			}
		} catch (Exception e) {
			LOG.error("Error in Saving TODO:", e);
			FacesContext.getCurrentInstance().addMessage(null,
					new FacesMessage(FacesMessage.SEVERITY_ERROR, ERR_PRCS_RQST, ERR_PRCS_RQST));
		}
	}

	public List<String> getTxFacilities(PatientDTO patient) {
		List<String> str =  new ArrayList<String>();
		if(patient.getFacilities()==null || patient.getFacilities().size()==0){
			str.add("N/A");
			return str;
		}
		Iterator itr = patient.getFacilities().iterator();
		while (itr.hasNext()) {
			FacilityDTO facility = (FacilityDTO)itr.next();
			FacilityInfoDTO fi = facility.getFacilityInfo();
			if(fi != null){
				str.add(fi.getName());
			}
			else{
				str.add(facility.getName());
			}
		}
		return str;
	}

	private PatientDTO getPatient(Long userProfileId) {
		PatientDTO patientDTO = new PatientDTO();
		try {
			// PatientService patientService = (PatientService)
			// SpringContext.getApplicationContext()
			// .getBean("patientProxy");
			patientDTO = patientProxy.getPatientByUserProfileId(userProfileId);

		} catch (MHVException e) {
			FacesContext.getCurrentInstance().addMessage(null,
					new FacesMessage(FacesMessage.SEVERITY_ERROR, e.getFailureMessage(), null));
			LOG.error("Error in resetpassword", e);
		}
		return patientDTO;
	}

	private InPersonAuthenticationSearchResultDTO getipaSearchResultDTO(PatientDTO patientDTO) {
		InPersonAuthenticationSearchResultDTO ipaSearchResultDTO = new InPersonAuthenticationSearchResultDTO();
		ipaSearchResultDTO.setId(patientDTO.getId());
		ipaSearchResultDTO.setName(patientDTO.getUserProfile().getLastName()+","+patientDTO.getUserProfile().getFirstName()+" "+(patientDTO.getUserProfile().getMiddleName() != null ? patientDTO.getUserProfile().getMiddleName() : ""));
		ipaSearchResultDTO.setFirstName(patientDTO.getUserProfile().getFirstName());
		ipaSearchResultDTO.setMiddleName(patientDTO.getUserProfile().getMiddleName());
		ipaSearchResultDTO.setLastName(patientDTO.getUserProfile().getLastName());
		ipaSearchResultDTO.setUserProfileId(patientDTO.getUserProfile().getId());
		ipaSearchResultDTO.setGender(patientDTO.getUserProfile().getGender());
		ipaSearchResultDTO.setSsn(patientDTO.getUserProfile().getSsn());
		ipaSearchResultDTO.setBirthDate(patientDTO.getUserProfile().getBirthDate());

		if (patientDTO.getCorrelationStatus() != null) {
			if (patientDTO.getCorrelationStatus() == 0) {
				ipaSearchResultDTO.setCorrelationStatus("Uncorrelated");
			} else if (patientDTO.getCorrelationStatus() == 1) {
				ipaSearchResultDTO.setCorrelationStatus("Pending Correlation");
			} else if (patientDTO.getCorrelationStatus() == 3) {
				ipaSearchResultDTO.setCorrelationStatus("Pending Uncorrelation");
			} else if (patientDTO.getCorrelationStatus() == 2) {
				ipaSearchResultDTO.setCorrelationStatus("Correlated");
			} else if (patientDTO.getCorrelationStatus() == 6) {
				ipaSearchResultDTO.setCorrelationStatus("Correlation Invalid");
			} else if (patientDTO.getCorrelationStatus() == 5) {
				ipaSearchResultDTO.setCorrelationStatus("Failed Correlation");
			} else if (patientDTO.getCorrelationStatus() == 4) {
				ipaSearchResultDTO.setCorrelationStatus("Failed Uncorrelation");
			} else if (patientDTO.getCorrelationStatus() == 7) {
				ipaSearchResultDTO.setCorrelationStatus("MviDataMatch");
			}
		} else {
			ipaSearchResultDTO.setCorrelationStatus("");
		}

		InPersonAuthenticationDTO ipaDTO = new InPersonAuthenticationDTO();
		if (patientDTO.getIpas().size() > 0) {
			for (Iterator iterator = patientDTO.getIpas().iterator(); iterator.hasNext();) {
				ipaDTO = (InPersonAuthenticationDTO) iterator.next();
				break;
			}
		}

		ipaSearchResultDTO.setAuthenticationDate(ipaDTO.getAuthenticationDate());

		String authenticationStatus = ipaDTO.getStatus();
		String authenticationStatusStr = "";
		if (authenticationStatus != null) {
			if (authenticationStatus.compareToIgnoreCase("Authenticated") == 0)
				authenticationStatusStr = authenticationStatus + (ipaSearchResultDTO.getAuthenticationDate() != null ? " on "+ (new SimpleDateFormat(TIME_FORMAT)).format(ipaSearchResultDTO.getAuthenticationDate()) : "");
			else
				authenticationStatusStr = authenticationStatus;
		}

		ipaSearchResultDTO.setAuthenticationStatus(authenticationStatusStr);

		try {
			if (ipaDTO.getAuthenticatingFacilityId() != null) {
				System.out.println(">>>> InPersonAuthenticatonController - getipaSearchResultDTO - ipaDTO.getAuthenticatingFacilityId() is not null");
				ipaSearchResultDTO.setAuthenticatingFacility(facilityInfoProxy.getFacilityInfoById(ipaDTO.getAuthenticatingFacilityId()).getName());
			}
			else {
				System.out.println(">>>> InPersonAuthenticatonController - getipaSearchResultDTO - ipaDTO.getAuthenticatingFacilityId() is null");
				ipaSearchResultDTO.setAuthenticatingFacility("N/A");
			}
		} catch (MHVException e) {
			System.out.println(">>>> InPersonAuthenticatonController - getipaSearchResultDTO - Error during getipaSearchResultDTO");
			LOG.error(">>>> InPersonAuthenticatonController - getipaSearchResultDTO - Error during getipaSearchResultDTO", e);
		}
		return ipaSearchResultDTO;
	}

	public String reset() {
		String adminUserName = getAdminUserName();
		InPersonAuthenticationDTO ipaResponse = null;
		try {
			PatientDTO patient = getPatient(userProfileInfo.getSelectedProfile().getId());
			System.out.println(">>>> InPersonAuthenticatonController - deferAuthentication - ICN:" + patient.getIcn());
			InPersonAuthenticationDTO ipa = getIPA(patient);
			if (ipa != null) {
				System.out.println(">>>> InPersonAuthenticatonController - deferAuthentication - ICN: IPA NOT NULL"
						+ patient.getIcn());
				//ipaResponse = inPersonAuthenticationProxy.deferAuthentication(ipa.getId(), adminUserName);

				patient = ipaResponse.getPatient();
				userProfileInfo.setSelectedProfile(patient.getUserProfile());
			} else {
				System.out.println(">>>> InPersonAuthenticatonController - deferAuthentication - ICN: IPA NULL"
						+ patient.getIcn());
			}

			System.out
					.println(">>>> InPersonAuthenticatonController - deferAuthentication - ICN2:" + patient.getIcn());
			System.out.println("deferAuthentication completed successfully");
		//} catch (MHVException e) {
		//	LOG.error("Error in Saving TODO", e);
		//	processErrorMessages(e);
		} catch (Exception e) {
			LOG.error("Error in Saving TODO:", e);
			FacesContext.getCurrentInstance().addMessage(null,
					new FacesMessage(FacesMessage.SEVERITY_ERROR, ERR_PRCS_RQST, ERR_PRCS_RQST));
		}
		return "search?faces-redirect=true";
	}


	public String printerFriendlyView() {
		InPersonAuthenticationDTO ipaResponse = null;
		try {
			System.out.println(">>>> InPersonAuthenticatonController - printerFriendlyView");
		} catch (Exception e) {
			LOG.error("Error in printer Friendly View.", e);
		}
		return "searchResults?faces-redirect=true";
	}

	public String resetSearchIPA() {
		InPersonAuthenticationDTO ipaResponse = null;
		try {
			PatientDTO patient = getPatient(userProfileInfo.getSelectedProfile().getId());
			System.out.println(">>>> InPersonAuthenticatonController - resetSearchIPA - ICN:" + patient.getIcn());
			System.out.println(">>>> InPersonAuthenticatonController - resetSearchIPA - Reset of Search Screen completed successfully");
		} catch (Exception e) {
			LOG.error("Error in Reset of Search Screen.", e);
		}
		return "search?faces-redirect=true";
	}

	public String confirmRemoveAuthentication() {
		System.out.println(">>>> InPersonAuthenticatonController - confirmRemoveAuthentication");
		System.out.println(">>>> InPersonAuthenticatonController - confirmRemoveAuthentication - searchUserIPAForm.getRemoveAuthenticatingReason:"+searchUserIPAForm.getRemoveAuthenticatingReason());
		if (searchUserIPAForm.getRemoveAuthenticatingReason().compareToIgnoreCase("no_selection") == 0) {
			//Set the error message.
			FacesContext context = FacesContext.getCurrentInstance();
			FacesContext.getCurrentInstance().addMessage(null,new FacesMessage(FacesMessage.SEVERITY_ERROR, "You must specify a reason for removing the current MHV User's authentication.", "NO_WRAPPER"));
			context.getApplication().getNavigationHandler().handleNavigation(context, null, "removeAuthentication.xhtml");
			return null;
		} else {
			userProfileInfo.setRemoveAuthenticatingReason(searchUserIPAForm.getRemoveAuthenticatingReason());
			return "confirmRemoval?faces-redirect=true";
		}
	}

	public String confirmTerminateAuthentication() {
		System.out.println(">>>> InPersonAuthenticatonController - confirmTerminateAuthentication");
		return "confirmTermination?faces-redirect=true";
	}


	public String syncCorrelate() {
		String adminUserName = getAdminUserName();
		InPersonAuthenticationDTO ipaResponse = null;
		List<InPersonAuthenticationDTO> ipas = null;
		ResponseUtil<List<InPersonAuthenticationDTO>> response = new ResponseUtil<List<InPersonAuthenticationDTO>>();
		try {
			PatientDTO patient = getPatient(userProfileInfo.getSelectedProfile().getId());
			InPersonAuthenticationDTO ipaDTO = getIPA(patient);
			if (ipaDTO != null) {
				response = inPersonAuthenticationProxy.syncCorrelate(ipaDTO,adminUserName);
				System.out.println( ">>>> InPersonAuthenticatonController - syncCorrelate - Correlation Service call completed");
				if (response.isFailure()) {
					FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, response.getFailureMessage(),"NO_WRAPPER"));
				} else {
					ipas = (List<InPersonAuthenticationDTO>) response.getPojoObject();
					ipaResponse = ipas.get(0);
					processInfoMessagesNoWrap(response);
				}
			}

			/*
			if(patient != null) {
				//currentIPA.setPatient(patient);
				setSelectedUserProfileAccountStatus(getAccountStatus(patient));
			}
			// updateSearchResults();
			// determineMatchStatus();
			// determineDisplayButtons();
			*/
			// TODO after processing, send it to the current page.
			System.out.println(">>>> InPersonAuthenticatonController - syncCorrelate - Correlation completed successfully");
		} catch (MHVException e) {
			System.out.println(">>>> InPersonAuthenticatonController - syncCorrelate - Error during Correlation Process.");
			LOG.error(">>>> InPersonAuthenticatonController - syncCorrelate - syncCorrelate during Correlation Process.", e);
			// processErrorMessages(e);
		} catch (Exception e) {
			System.out.println(">>>> InPersonAuthenticatonController - syncCorrelate - Error during Correlation Process.");
			LOG.error(">>>> InPersonAuthenticatonController - syncCorrelate - Error during Correlation Process.", e);
			FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, ERR_PRCS_RQST, ERR_PRCS_RQST));
		}
		
		// Refresh the details page after Match operation. 
		return performAuthentication();
		
		//FacesContext context = FacesContext.getCurrentInstance();
		//context.getApplication().getNavigationHandler().handleNavigation(context, null, "searchResults.xhtml");
		//return null;
	}

	public String match() {
		String adminUserName = getAdminUserName();
		InPersonAuthenticationDTO ipaResponse = null;
		List<InPersonAuthenticationDTO> ipas = null;
		ResponseUtil<List<InPersonAuthenticationDTO>> response = new ResponseUtil<List<InPersonAuthenticationDTO>>();
		try {
			PatientDTO patient = getPatient(userProfileInfo.getSelectedProfile().getId());
			InPersonAuthenticationDTO ipaDTO = getIPA(patient);
			if (ipaDTO != null) {
				response = inPersonAuthenticationProxy.match(ipaDTO,adminUserName);
				System.out.println( ">>>> InPersonAuthenticatonController - match - Match Service call completed");
				if (response.isFailure()) {
					FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, response.getFailureMessage(),"NO_WRAPPER"));
				} else {
					ipas = (List<InPersonAuthenticationDTO>) response.getPojoObject();
					ipaResponse = ipas.get(0);
					processInfoMessagesNoWrap(response);
				}
			}

			/*
			if(patient != null) {
				//currentIPA.setPatient(patient);
				setSelectedUserProfileAccountStatus(getAccountStatus(patient));
			}


			// updateSearchResults();
			// determineMatchStatus();
			// determineDisplayButtons();

			*/
			// TODO after processing, send it to the current page.
			System.out.println(">>>> InPersonAuthenticatonController - match - Match completed successfully");
		} catch (MHVException e) {
			System.out.println(">>>> InPersonAuthenticatonController - match - Error during Match Process.");
			LOG.error(">>>> InPersonAuthenticatonController - match - Error during Match Process.", e);
			// processErrorMessages(e);
		} catch (Exception e) {
			System.out.println(">>>> InPersonAuthenticatonController - match - Error during Match Process.");
			LOG.error(">>>> InPersonAuthenticatonController - match - Error during Match Process.", e);
			FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, ERR_PRCS_RQST, ERR_PRCS_RQST));
		}
		
		// Refresh the details page after Match operation. 
		return performAuthentication();
		
		//FacesContext context = FacesContext.getCurrentInstance();
		//context.getApplication().getNavigationHandler().handleNavigation(context, null, "searchResults.xhtml");
		//return null;
	}

	public String basicMatch() {
		String adminUserName = getAdminUserName();
		InPersonAuthenticationDTO ipaResponse = null;
		List<InPersonAuthenticationDTO> ipas = null;
		ResponseUtil<List<InPersonAuthenticationDTO>> response = new ResponseUtil<List<InPersonAuthenticationDTO>>();
		try {
			PatientDTO patient = getPatient(userProfileInfo.getSelectedProfile().getId());
			InPersonAuthenticationDTO ipaDTO = getIPA(patient);
			if (ipaDTO != null) {
				response = inPersonAuthenticationProxy.match(ipaDTO,adminUserName);
				System.out.println( ">>>> InPersonAuthenticatonController - basicMatch - Match Service call completed");
				if (response.isFailure()) {
					FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, response.getFailureMessage(),"NO_WRAPPER"));
				} else {
					ipas = (List<InPersonAuthenticationDTO>) response.getPojoObject();
					ipaResponse = ipas.get(0);
					processInfoMessages(response);
				}
			}

			//JAZZ Defect #  140899 - Make sure the refresh happens after the match.
			/*
	        if (selectedProfile == null) {
	        	setSelectedUserProfileName("");
	        } else {
	        	StringBuffer buffer = new StringBuffer();
	        	buffer.append(selectedProfile.getFirstName()!=null?selectedProfile.getFirstName():"");
	        	buffer.append(" ");
	        	buffer.append(selectedProfile.getMiddleName()!=null?selectedProfile.getMiddleName():"");
	        	buffer.append(" ");
	        	buffer.append(selectedProfile.getLastName()!=null?selectedProfile.getLastName():"");
	        	setSelectedUserProfileName(buffer.toString());
	        }

	  		//MHV_CodeCR1387 - Added relationship to VA in search detail page.
			StringBuffer relationshipToVA = new StringBuffer("");
			if(selectedProfile.getIsPatient()) {
				relationshipToVA.append("VA Patient");
			}

			if(selectedProfile.getIsVeteran()) {
				if(relationshipToVA.length() > 0) {
					relationshipToVA.append(", ");
				}
				relationshipToVA.append("Veteran");
			}

			if(selectedProfile.getIsHealthCareProvider()) {
				if(relationshipToVA.length() > 0) {
					relationshipToVA.append(", ");
				}
				relationshipToVA.append("Health Care Provider");
			}

			if(selectedProfile.getIsPatientAdvocate()) {
				if(relationshipToVA.length() > 0) {
					relationshipToVA.append(", ");
				}
				relationshipToVA.append("Veteran Advocate/Family Member/Friend");
			}

			if(selectedProfile.getIsEmployee()) {
				if(relationshipToVA.length() > 0) {
					relationshipToVA.append(", ");
				}
				relationshipToVA.append("VA Employee");
			}

			if(selectedProfile.getIsOther()) {
				if(relationshipToVA.length() > 0) {
					relationshipToVA.append(", ");
				}
				relationshipToVA.append("Other");
			}

			setSelectedUserProfileVaRelationship(relationshipToVA.toString());

			if(selectedProfile.getCreatedDate()!=null){
				// Account Created Date
				setSelectedUserProfileCreatedDate(new SimpleDateFormat(TIME_FORMAT).format(selectedProfile.getCreatedDate()));
			}

		//MHV_CodeCR1514 - US12.4 MVI Compliance Implementation - Adding Correlation Status fields

		//JAZZ:Defect 19451 - Make sure the fields are refreshed when the new user is selected.
		setSelectedUserProfileMatchingStatus("Unmatched");
		setSelectedUserProfileTreatingFacilities("");
		setSelectedUserProfileCorrelationStatus("");
		setSelectedUserProfileCorrelationDate("");
		setSelectedUserProfileCorrelationRequestDate("");
		setSelectedUserProfileCorrelationPerformedBy("");
		setSelectedUserProfileAuthenticationStatus("");
		setSelectedUserProfileAuthenticationDate("");
		setSelectedUserProfileAuthenticatingFacility("");
		setSelectedUserProfileAuthenticatedBy("");
		setSelectedUserProfileAccountStatus("");
		setSelectedUserProfileStartUpgradeAutoDate("");
		setSelectedUserProfileStartUpgradeManualDate("");
		setSelectedUserProfileSignedErarDate("");

		setSelectedUserProfileMatchingStatus("Unmatched");
		setSelectedUserProfileMatchingDate("");

		setLastLoginDateTime("");
		setLastSMLoginDateTime("");
		setSignInPartners("");

        if(selectedProfile.getCurrentLogin() != null) {
        	setLastLoginDateTime(new SimpleDateFormat(TIME_FORMAT).format(selectedProfile.getCurrentLogin()));
        }

        if(selectedProfile.getSignInPartners() != null) {
        	setSignInPartners(selectedProfile.getSignInPartners());
        }

        SMSUserViewServiceResponse smResponse = ServiceDelegateFactory.createUserProfileServiceDelegate().getSMUser(selectedProfile.getUserName());
        if(smResponse.getSMSUserView() != null && smResponse.getSMSUserView().getCurrentLogin() != null) {
        	setLastSMLoginDateTime(new SimpleDateFormat(TIME_FORMAT).format(smResponse.getSMSUserView().getCurrentLogin()));
        }

		patient = getPatient(selectedProfile);
		displayMatchButton = false;

		if(patient !=null && patient.getMatchedDateTime()==null && selectedProfile.getDeactivationReason() == null) {
			displayMatchButton = true;
		} else if(patient ==null && (selectedProfile.getIsPatient()||selectedProfile.getIsVeteran())) {
			displayMatchButton = true;
		}

		if(patient != null) {
			if(patient.getMatchedDateTime()!=null) {
				setSelectedUserProfileMatchingStatus("Matched");
				setSelectedUserProfileMatchingDate(
						new SimpleDateFormat(TIME_FORMAT).format(patient.getMatchedDateTime()));
			}
			InPersonAuthentication ipa = getIPA(patient);
			setSelectedUserProfileTreatingFacilities(getTxFacilities(patient));
			setSelectedUserProfileCorrelationStatus(getCorrelationStatus(patient));
			setSelectedUserProfileCorrelationDate(getCorrelationDate(patient));
			setSelectedUserProfileCorrelationRequestDate(getCorrelationRequestDate(patient));
			setSelectedUserProfileCorrelationPerformedBy(getCorrelatedBy(patient));
			if(ipa != null) {
				setSelectedUserProfileAuthenticationStatus(getAuthenticationStatus(ipa));
				setSelectedUserProfileAuthenticationDate(getAuthenticationDate(ipa));
				setSelectedUserProfileAuthenticatingFacility(getAuthenticatingFacility(ipa));
				setSelectedUserProfileAuthenticatedBy(getAuthenticatedBy(ipa));
				setSelectedUserProfileStartUpgradeAutoDate(getStartUpgradeAutoDate(ipa));
				setSelectedUserProfileStartUpgradeManualDate(getStartUpgradeManualDate(ipa));
				setSelectedUserProfileSignedErarDate(getSignedFormOnlineDateTime(ipa));

				//JAZZ#32763 US02 RQ#5- The MHV system shall check if the Signed 10-5345a-MHV form online field is set and display two new buttons:
				StringServiceResponse vapiiStatusResponse =
					gov.va.med.mhv.usermgmt.service.delegate.ServiceDelegateFactory.createUserProfileServiceDelegate().getVapiiFormStatusForUser(
							ipa.getPatient().getUserProfile());

				if(vapiiStatusResponse.getMessages().hasErrorMessages() && ipa != null && ipa.getSignedFormOnlineDateTime()!=null) {
					getRequest().getSession().setAttribute("displayError", "vapiiError");
					if (LOG.isDebugEnabled()) {
						LOG.debug("********** InPersonAuthenticatonController.performBasicSearchDetail() vapiiStatusResponse.getMessages().hasErrorMessages() && ipa != null && ipa.getSignedFormOnlineDateTime()!=null");
					}
				}else if(!"Submitted".equalsIgnoreCase(vapiiStatusResponse.getString()) && ipa != null && ipa.getSignedFormOnlineDateTime()!=null) {
					getRequest().getSession().setAttribute("displayError", "formNotFound");
					if (LOG.isDebugEnabled()) {
						LOG.debug("********** InPersonAuthenticatonController.performBasicSearchDetail() !Submitted.equalsIgnoreCase(vapiiStatusResponse.getString()) && ipa != null && ipa.getSignedFormOnlineDateTime()!=null");
					}
				} else {
					if (LOG.isDebugEnabled()) {
						LOG.debug("********** InPersonAuthenticatonController.performBasicSearchDetail() getRequest().getSession().removeAttribute(displayError)");
					}
					getRequest().getSession().removeAttribute("displayError");
				}

				if(ipa.getSignedFormOnlineDateTime()!=null) {
					if (LOG.isDebugEnabled()) {
						LOG.debug("********** InPersonAuthenticatonController.performBasicSearchDetail() ipa.getSignedFormOnlineDateTime()!=null");
					}
					setDisplayDownloadERARButton(true);
				} else {
					if (LOG.isDebugEnabled()) {
						LOG.debug("********** InPersonAuthenticatonController.performBasicSearchDetail() ipa.getSignedFormOnlineDateTime()==null");
					}
					setDisplayDownloadERARButton(false);
				}
			}
		}
		setSelectedUserProfileAccountStatus(getAccountStatus(patient));

	    //CR1838 - Made sure that the search results are updated
		updateSearchResults();
		determineDisplayButtons();

		*/


			System.out.println(">>>> InPersonAuthenticatonController - basicMatch - Match completed successfully");
		} catch (MHVException e) {
			System.out.println(">>>> InPersonAuthenticatonController - basicMatch - Error during Match Process.");
			LOG.error(">>>> InPersonAuthenticatonController - basicMatch - Error during Match Process.", e);
			// processErrorMessages(e);
		} catch (Exception e) {
			System.out.println(">>>> InPersonAuthenticatonController - basicMatch - Error during Match Process.");
			LOG.error(">>>> InPersonAuthenticatonController - basicMatch - Error during Match Process.", e);
			FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, ERR_PRCS_RQST, ERR_PRCS_RQST));
		}
		FacesContext context = FacesContext.getCurrentInstance();
		context.getApplication().getNavigationHandler().handleNavigation(context, null, "basicSearchDetail.xhtml");
		return null;
		//return "searchResults?faces-redirect=true";
	}


	public String terminateAuthentication() {
		InPersonAuthenticationDTO ipaResponse = null;
		List<InPersonAuthenticationDTO> ipas = null;
		ResponseUtil<List<InPersonAuthenticationDTO>> response = new ResponseUtil<List<InPersonAuthenticationDTO>>();
		try {
			PatientDTO patient = getPatient(userProfileInfo.getSelectedProfile().getId());
			InPersonAuthenticationDTO ipaDTO = getIPA(patient);
			if (ipaDTO != null) {
				if (null != searchUserIPAForm.getAuthenticatingFacility()) {
					ipaDTO.setAuthenticatingFacilityDTO(facilityInfoProxy.getFacilityInfoById(Long.parseLong(searchUserIPAForm.getAuthenticatingFacility())));
					ipaDTO.setAuthenticatingFacilityId(Long.parseLong(searchUserIPAForm.getAuthenticatingFacility()));
				}
				response = inPersonAuthenticationProxy.terminateAuthentication(ipaDTO);
				System.out.println( ">>>> InPersonAuthenticatonController - terminateAuthentication - Terminate Authentication Service call completed");
				ipas = (List<InPersonAuthenticationDTO>) response.getPojoObject();
				ipaResponse = ipas.get(0);
				processInfoMessages(response);
			}
			System.out.println(">>>> InPersonAuthenticatonController - terminateAuthentication - Terminate Authentication completed successfully");
		} catch (MHVException e) {
			System.out.println(">>>> InPersonAuthenticatonController - terminateAuthentication - Error during Terminate Authentication");
			LOG.error(">>>> InPersonAuthenticatonController - terminateAuthentication - Error during Terminate Authentication", e);
			// processErrorMessages(e);
		} catch (Exception e) {
			System.out.println(">>>> InPersonAuthenticatonController - terminateAuthentication - Error during Terminate Authentication");
			LOG.error(">>>> InPersonAuthenticatonController - terminateAuthentication - Error during Terminate Authentication", e);
			FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, ERR_PRCS_RQST, ERR_PRCS_RQST));
		}

		//Refresh the Search Results page - 
		if (userProfileInfo.getCurrentSearchCriteriaDTO() != null) {
			findUserIPA(userProfileInfo.getCurrentSearchCriteriaDTO());
		}
				
		FacesContext context = FacesContext.getCurrentInstance();
		context.getApplication().getNavigationHandler().handleNavigation(context, null, "searchResults.xhtml");
		return null;
		//return "searchResults?faces-redirect=true";
	}

	public String deferAuthentication() {
		InPersonAuthenticationDTO ipaResponse = null;
		List<InPersonAuthenticationDTO> ipas = null;
		ResponseUtil<List<InPersonAuthenticationDTO>> response = new ResponseUtil<List<InPersonAuthenticationDTO>>();
		try {
			PatientDTO patient = getPatient(userProfileInfo.getSelectedProfile().getId());
			InPersonAuthenticationDTO ipaDTO = getIPA(patient);
			System.out.println(">>>> InPersonAuthenticatonController - deferAuthentication - ipaDTO.getPatient().getId():" + ipaDTO.getPatient().getId());
			if (ipaDTO != null) {
				System.out.println(">>>> InPersonAuthenticatonController - deferAuthentication - searchUserIPAForm.getDelayReason:" + searchUserIPAForm.getDelayReason());

				// Validations -
				Boolean isValidationFailed = false;
				FacesContext context = FacesContext.getCurrentInstance();
				if (searchUserIPAForm.getDelayReason() == null || StringUtils.isBlank(searchUserIPAForm.getDelayReason())) {
					FacesContext.getCurrentInstance().addMessage(null,new FacesMessage(FacesMessage.SEVERITY_ERROR, "You must specify a reason for delaying the current MHV User's authentication.", "NO_WRAPPER"));
					 isValidationFailed = true;
				}
				if (searchUserIPAForm.getAuthenticatingFacility() == null || StringUtils.isBlank(searchUserIPAForm.getAuthenticatingFacility())) {
					FacesContext.getCurrentInstance().addMessage(null,new FacesMessage(FacesMessage.SEVERITY_ERROR, "Authenticating Facility is a required field.", "NO_WRAPPER"));
					isValidationFailed = true;
				}
				if (searchUserIPAForm.getIpaApprovedForRecordsAccess()) {
					FacesContext.getCurrentInstance().addMessage(null,new FacesMessage(FacesMessage.SEVERITY_ERROR, "The user cannot be approved for electronic record access when delaying authentication.", "NO_WRAPPER"));
					isValidationFailed = true;
				}
				if (isValidationFailed) {
					context.getApplication().getNavigationHandler().handleNavigation(context, null, "authenticatePatient.xhtml");
					return null;
				}

				ipaDTO.setDefermentReason(searchUserIPAForm.getDelayReason());
				ipaDTO.setParticipationFormSigned(searchUserIPAForm.getIpaParticipationFormSigned());
				ipaDTO.setIdentificationPresented(searchUserIPAForm.getIpaIdentificationPresented());
				ipaDTO.setAuthenticatingFacilityDTO(facilityInfoProxy.getFacilityInfoById(Long.parseLong(searchUserIPAForm.getAuthenticatingFacility())));
				ipaDTO.setAuthenticatingFacilityId(Long.parseLong(searchUserIPAForm.getAuthenticatingFacility()));

				System.out.println(">>>> InPersonAuthenticatonController - deferAuthentication - ipaDTO.getPatient().getId():" + ipaDTO.getPatient().getId());
				System.out.println(">>>> InPersonAuthenticatonController - deferAuthentication - ipaDTO.getPatientId():" + ipaDTO.getPatientId());

				System.out.println(">>>> InPersonAuthenticatonController - deferAuthentication - ipaDTO.getAuthenticatingFacilityDTO().getId():" + ipaDTO.getAuthenticatingFacilityDTO().getId());
				System.out.println(">>>> InPersonAuthenticatonController - deferAuthentication - ipaDTO.getAuthenticatingFacilityId():" + ipaDTO.getAuthenticatingFacilityId());

				response = inPersonAuthenticationProxy.deferAuthentication(ipaDTO);
				System.out.println( ">>>> InPersonAuthenticatonController - deferAuthentication - deferAuthentication Service call completed");
				ipas = (List<InPersonAuthenticationDTO>) response.getPojoObject();
				ipaResponse = ipas.get(0);
				System.out.println(">>>> InPersonAuthenticatonController - deferAuthentication - ipaResponse IPA Id:" + ipaResponse.getId());
				processInfoMessages(response);
			}
			System.out.println(">>>> InPersonAuthenticatonController - deferAuthentication - DeferAuthentication completed successfully");
		} catch (MHVException e) {
			System.out.println(">>>> InPersonAuthenticatonController - deferAuthentication - Error during Defer Authentication");
			LOG.error(">>>> InPersonAuthenticatonController - deferAuthentication - Error during Defer Authentication", e);
			// processErrorMessages(e);
		} catch (Exception e) {
			System.out.println(">>>> InPersonAuthenticatonController - deferAuthentication - Error during Defer Authentication");
			LOG.error(">>>> InPersonAuthenticatonController - deferAuthentication - Error during Defer Authentication", e);
			FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, ERR_PRCS_RQST, ERR_PRCS_RQST));
		}

		//Refresh the Search Results page - 
		if (userProfileInfo.getCurrentSearchCriteriaDTO() != null) {
			findUserIPA(userProfileInfo.getCurrentSearchCriteriaDTO());
		}
				
		FacesContext context = FacesContext.getCurrentInstance();
		context.getApplication().getNavigationHandler().handleNavigation(context, null, "searchResults.xhtml");
		return null;
	}

	// Perform Authentication
	public String authenticate() {
		String adminUserName = getAdminUserName();
		InPersonAuthenticationDTO ipaResponse = null;
		List<InPersonAuthenticationDTO> ipas = null;
		ResponseUtil<List<InPersonAuthenticationDTO>> response = new ResponseUtil<List<InPersonAuthenticationDTO>>();
		System.out.println(">>>> InPersonAuthenticatonController - authentication - Enter:");
		try {
			PatientDTO patient = getPatient(userProfileInfo.getSelectedProfile().getId());
			InPersonAuthenticationDTO ipaDTO = getIPA(patient);
			if (ipaDTO != null) {
				// Validations -
				Boolean isValidationFailed = false;
				FacesContext context = FacesContext.getCurrentInstance();
				if (searchUserIPAForm.getAuthenticatingFacility() == null || StringUtils.isBlank(searchUserIPAForm.getAuthenticatingFacility())) {
					FacesContext.getCurrentInstance().addMessage(null,new FacesMessage(FacesMessage.SEVERITY_ERROR, "Authenticating Facility is a required field.", "NO_WRAPPER"));
					isValidationFailed = true;
				}
				if (!searchUserIPAForm.getIpaParticipationFormSigned() || !searchUserIPAForm.getIpaIdentificationPresented() || !searchUserIPAForm.getIpaApprovedForRecordsAccess()) {
					FacesContext.getCurrentInstance().addMessage(null,new FacesMessage(FacesMessage.SEVERITY_ERROR, "All prerequisites must be selected in order to authenticate the user.", "NO_WRAPPER"));
					 isValidationFailed = true;
				}
				if (isValidationFailed) {
					context.getApplication().getNavigationHandler().handleNavigation(context, null, "authenticatePatient.xhtml");
					return null;
				}

				ipaDTO.setDefermentReason(searchUserIPAForm.getDelayReason());
				ipaDTO.setParticipationFormSigned(searchUserIPAForm.getIpaParticipationFormSigned());
				ipaDTO.setIdentificationPresented(searchUserIPAForm.getIpaIdentificationPresented());
				ipaDTO.setApprovedForRecordsAccess(searchUserIPAForm.getIpaApprovedForRecordsAccess());
				ipaDTO.setAuthenticatingFacilityDTO(facilityInfoProxy.getFacilityInfoById(Long.parseLong(searchUserIPAForm.getAuthenticatingFacility())));
				ipaDTO.setAuthenticatingFacilityId(Long.parseLong(searchUserIPAForm.getAuthenticatingFacility()));

				System.out.println(">>>> InPersonAuthenticatonController - authentication - ipaDTO.getPatient().getId():" + ipaDTO.getPatient().getId());
				System.out.println(">>>> InPersonAuthenticatonController - authentication - ipaDTO.getPatientId():" + ipaDTO.getPatientId());

				System.out.println(">>>> InPersonAuthenticatonController - authentication - ipaDTO.getAuthenticatingFacilityDTO().getId():" + ipaDTO.getAuthenticatingFacilityDTO().getId());
				System.out.println(">>>> InPersonAuthenticatonController - authentication - ipaDTO.getAuthenticatingFacilityId():" + ipaDTO.getAuthenticatingFacilityId());

				response = inPersonAuthenticationProxy.authenticateWithAdminUserName(ipaDTO.getId(), adminUserName, ipaDTO.getAuthenticatingFacilityId());
				System.out.println(">>>> InPersonAuthenticatonController - authentication - authenticateWithAdminUserName Service call completed");
				if (response.isFailure()) {
					FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, response.getFailureMessage(),"NO_WRAPPER"));
				} else {				
					ipas = (List<InPersonAuthenticationDTO>) response.getPojoObject();
					ipaResponse = ipas.get(0);
					System.out.println(">>>> InPersonAuthenticatonController - authentication - ipaResponse IPA Id:"+ipaResponse.getId());
					//processInfoMessagesNoWrap(response);
					FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, response.getSuccessMessage(),response.getSuccessMessage()));					
				}
			}
			System.out.println("Authentication completed successfully");
		} catch (MHVException e) {
			LOG.error(">>>> InPersonAuthenticatonController - authentication - Error during Authentication", e);
			System.out.println(">>>> InPersonAuthenticatonController - authentication - Error during Authentication");
			//processErrorMessages(e);
			return "";
		} catch (Exception e) {
			System.out.println(">>>> InPersonAuthenticatonController - authentication - Error during Authentication");
			LOG.error(">>>> InPersonAuthenticatonController - authentication - Error during Authentication", e);
			FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, ERR_PRCS_RQST, ERR_PRCS_RQST));
			return "";
		}
		
		//Refresh the Search Results page - 
		if (userProfileInfo.getCurrentSearchCriteriaDTO() != null) {
			findUserIPA(userProfileInfo.getCurrentSearchCriteriaDTO());
		}
				
		System.out.println(">>>> InPersonAuthenticatonController - authentication - calling reloadPerformAuthentication:"+ userProfileInfo.getSelectedProfile().getId());
		FacesContext context = FacesContext.getCurrentInstance();
		context.getApplication().getNavigationHandler().handleNavigation(context, null, "searchResults.xhtml");
		return null;
	}

	public String removeAuthentication() {
		String adminUserName = getAdminUserName();
		InPersonAuthenticationDTO ipaResponse = null;
		List<InPersonAuthenticationDTO> ipas = null;
		ResponseUtil<List<InPersonAuthenticationDTO>> response = new ResponseUtil<List<InPersonAuthenticationDTO>>();
		try {
			PatientDTO patient = getPatient(userProfileInfo.getSelectedProfile().getId());
			System.out.println(">>>> InPersonAuthenticatonController - removeAuthentication - ICN:" + patient.getIcn());
			InPersonAuthenticationDTO ipa = getIPA(patient);
			if (ipa != null) {
				System.out.println(">>>> InPersonAuthenticatonController - removeAuthentication - ICN: IPA NOT NULL" + patient.getIcn());

				System.out.println(">>>> InPersonAuthenticatonController - removeAuthentication - userProfileInfo.getRemoveAuthenticatingReason:"+userProfileInfo.getRemoveAuthenticatingReason());
				response = inPersonAuthenticationProxy.unauthenticateWithAdminUserName(ipa.getId(), adminUserName, userProfileInfo.getRemoveAuthenticatingReason());
				System.out.println(">>>> InPersonAuthenticatonController - removeAuthentication - unauthenticateWithAdminUserName Service call completed");
				if (response.isFailure()) {
					FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, response.getFailureMessage(),"NO_WRAPPER"));
				} else {
					ipas = (List<InPersonAuthenticationDTO>) response.getPojoObject();
					ipaResponse = ipas.get(0);
					System.out.println(">>>> InPersonAuthenticatonController - removeAuthentication - ipaResponse IPA Id:"+ipaResponse.getId());
					//processInfoMessagesNoWrap(response);
					FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, response.getSuccessMessage(),response.getSuccessMessage()));
				}
			}
			System.out.println("removeAuthentication completed successfully");
		} catch (MHVException e) {
			System.out.println(">>>> InPersonAuthenticatonController - removeAuthentication - Error during Remove Authentication");
			LOG.error(">>>> InPersonAuthenticatonController - removeAuthentication - Error during Remove Authentication", e);
			//processErrorMessages(e);
			return "";
		} catch (Exception e) {
			System.out.println(">>>> InPersonAuthenticatonController - removeAuthentication - Error during Remove Authentication");
			LOG.error(">>>> InPersonAuthenticatonController - removeAuthentication - Error during Remove Authentication", e);
			FacesContext.getCurrentInstance().addMessage(null,new FacesMessage(FacesMessage.SEVERITY_ERROR, ERR_PRCS_RQST, ERR_PRCS_RQST));
			return "";
		}

		//Refresh the Search Results page - 
		if (userProfileInfo.getCurrentSearchCriteriaDTO() != null) {
			findUserIPA(userProfileInfo.getCurrentSearchCriteriaDTO());
		}
		
		System.out.println(">>>> InPersonAuthenticatonController - removeAuthentication - calling reloadPerformAuthentication:"+ userProfileInfo.getSelectedProfile().getId());
		FacesContext context = FacesContext.getCurrentInstance();
		context.getApplication().getNavigationHandler().handleNavigation(context, null, "searchResults.xhtml");
		return null;
	}

	private InPersonAuthenticationDTO getIPA(PatientDTO patient) {

		InPersonAuthenticationDTO ipaDTO = null;
		try {
			ipaDTO = inPersonAuthenticationProxy.getAuthenticationForPatient(patient.getId());
		} catch (Exception e) {
			LOG.error("Error in Saving TODO:", e);
			FacesContext.getCurrentInstance().addMessage(null,
					new FacesMessage(FacesMessage.SEVERITY_ERROR, ERR_PRCS_RQST, ERR_PRCS_RQST));
		}

		return ipaDTO;
	}


	/**
	 * This method assembles the 3 pieces of ssn into a single ssn xxx-xx-xxxx
	 *
	 * @param ssn3
	 * @param ssn2
	 * @param ssn4
	 * @return
	 */
	private String assembleSsn(String ssn3, String ssn2, String ssn4) {

		StringBuilder sb = new StringBuilder();

		ssn3 = ("null".equalsIgnoreCase(ssn3) || (null != ssn3 && ssn3.length() == 0)) ? null : ssn3;
		ssn2 = ("null".equalsIgnoreCase(ssn2) || (null != ssn2 && ssn2.length() == 0)) ? null : ssn2;
		ssn4 = ("null".equalsIgnoreCase(ssn4) || (null != ssn4 && ssn4.length() == 0)) ? null : ssn4;

		if (null != ssn3 && null != ssn2 && null != ssn4) {
			sb.append(ssn3).append("-");
			sb.append(ssn2).append("-");
			sb.append(ssn4);

			return sb.toString();
		} else {
			return null;
		}
	}

	public SearchUserIPAFormBean getSearchUserIPAForm() {
		return searchUserIPAForm;
	}

	public void setSearchUserIPAForm(SearchUserIPAFormBean searchUserIPAForm) {
		this.searchUserIPAForm = searchUserIPAForm;
	}

	public SessionUtil getSessionUtil() {
		return sessionUtil;
	}

	public void setSessionUtil(SessionUtil sessionUtil) {
		this.sessionUtil = sessionUtil;
	}

	public SearchUserIPAResultsFormBean getSearchIPAResults() {
		return searchIPAResults;
	}

	public void setSearchIPAResults(SearchUserIPAResultsFormBean searchIPAResults) {
		this.searchIPAResults = searchIPAResults;
	}

	public UserProfileFormBean getUserProfileInfo() {
		return userProfileInfo;
	}

	public void setUserProfileInfo(UserProfileFormBean userProfileInfo) {
		this.userProfileInfo = userProfileInfo;
	}

	protected void processInfoMessages(ResponseUtil<List<InPersonAuthenticationDTO>> response) {

		Map<String, String> infoMessages = response.getInfoMessages();

		if (LOG.isDebugEnabled()) {
			int size = null != infoMessages ? infoMessages.size() : 0;
			LOG.debug(">>>> InPersonAuthenticatonController - processInfoMessages - infoMessages.size():"+ size);
			System.out.println(">>>> InPersonAuthenticatonController - processInfoMessages - infoMessages.size():"+size);
		}

		if (null != infoMessages && infoMessages.size() > 0) {
			for (Map.Entry<String, String> err : infoMessages.entrySet()) {
				if (LOG.isDebugEnabled()) {
					if (null != err) {
						LOG.debug(">>>> InPersonAuthenticatonController - processInfoMessages - Key is: "+ err.getKey() + "& Value is: "+err.getValue());
						System.out.println(">>>> InPersonAuthenticatonController - processInfoMessages - Key is: "+ err.getKey() + "& Value is: "+err.getValue());
					}
				}
				FacesContext.getCurrentInstance().addMessage(null,new FacesMessage(FacesMessage.SEVERITY_INFO, err.getValue(), err.getValue()));
			}
		}
	}

	protected void processInfoMessagesNoWrap(ResponseUtil<List<InPersonAuthenticationDTO>> response) {

		Map<String, String> infoMessages = response.getInfoMessages();

		if (LOG.isDebugEnabled()) {
			int size = null != infoMessages ? infoMessages.size() : 0;
			LOG.debug(">>>> InPersonAuthenticatonController - processInfoMessages - infoMessages.size():"+ size);
			System.out.println(">>>> InPersonAuthenticatonController - processInfoMessages - infoMessages.size():"+size);
		}

		if (null != infoMessages && infoMessages.size() > 0) {
			for (Map.Entry<String, String> err : infoMessages.entrySet()) {
				if (LOG.isDebugEnabled()) {
					if (null != err) {
						LOG.debug(">>>> InPersonAuthenticatonController - processInfoMessages - Key is: "+ err.getKey() + "& Value is: "+err.getValue());
						System.out.println(">>>> InPersonAuthenticatonController - processInfoMessages - Key is: "+ err.getKey() + "& Value is: "+err.getValue());
					}
				}
				FacesContext.getCurrentInstance().addMessage(null,new FacesMessage(FacesMessage.SEVERITY_INFO, err.getValue(), err.getValue()));
			}
		}
	}
	
	protected void processErrorMessages(MHVException exp) {
		// response has errors
		if (null != exp.getErrorCode()) {
			Map<String, String> validationErrors = exp.getValidationErrorMessages();

			if (LOG.isDebugEnabled()) {
				int size = null != validationErrors ? validationErrors.size() : 0;
				LOG.debug("validationErrors.size() : " + size);
			}

			// check if there are any validation errors in response object
			if (null != validationErrors && validationErrors.size() > 0) {

				for (Map.Entry<String, String> err : validationErrors.entrySet()) {
					if (LOG.isDebugEnabled()) {
						if (null != err) {
							LOG.debug("entry.getKey() : " + err.getKey());
							LOG.debug("entry.getValue() : " + err.getValue());
						}
					}
					FacesContext.getCurrentInstance().addMessage(null,
							new FacesMessage(FacesMessage.SEVERITY_ERROR, err.getValue(), err.getValue()));
				}
			}

			// check for non-validation errors in response object
			if (null != exp.getFailureMessage() && exp.getFailureMessage().length() > 0) {
				if (LOG.isDebugEnabled()) {
					LOG.debug("FailureMessage : " + exp.getFailureMessage());
				}

				FacesContext.getCurrentInstance().addMessage(null,
						new FacesMessage(FacesMessage.SEVERITY_ERROR, ERR_PRCS_RQST, ERR_PRCS_RQST));
			}
		}
	}

	public String getAdminUserName() {
		PortletRequest request = (PortletRequest) FacesContext.getCurrentInstance().getExternalContext().getRequest();
		HttpServletRequest httpRequest = PortalUtil.getHttpServletRequest(request);
		HttpSession session = httpRequest.getSession();		
		return (String) session.getAttribute("LIFERAY_SHARED_screenName");		
	}
	
	public InPersonAuthenticationService getInPersonAuthenticationProxy() {
		return inPersonAuthenticationProxy;
	}

	public void setInPersonAuthenticationProxy(InPersonAuthenticationService inPersonAuthenticationProxy) {
		this.inPersonAuthenticationProxy = inPersonAuthenticationProxy;
	}

	public PatientService getPatientProxy() {
		return patientProxy;
	}

	public void setPatientProxy(PatientService patientProxy) {
		this.patientProxy = patientProxy;
	}

	public UserProfileService getUserProfileProxy() {
		return userProfileProxy;
	}

	public void setUserProfileProxy(UserProfileService userProfileProxy) {
		this.userProfileProxy = userProfileProxy;
	}

	public FacilityInfoService getFacilityInfoProxy() {
		return facilityInfoProxy;
	}

	public void setFacilityInfoProxy(FacilityInfoService facilityInfoProxy) {
		this.facilityInfoProxy = facilityInfoProxy;
	}
}
