package gov.va.med.mhv.admin.web.util;

import com.liferay.portal.util.PortalUtil;

import gov.va.med.mhv.admin.dto.EmployeeDTO;
import gov.va.med.mhv.admin.service.vastaff.AdminUserService;
import gov.va.med.mhv.common.api.exception.MHVException;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;
import javax.portlet.PortletRequest;
import javax.servlet.http.HttpSession;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.BeansException;

@ManagedBean(name="sessionUtil")
@SessionScoped
public class SessionUtil implements Serializable {

	private static final long serialVersionUID = -6201280086591484208L;

	private static Logger log = LogManager.getLogger(SessionUtil.class);

	EmployeeDTO employee = null;
	
	public SessionUtil() {
	}
	
	/**
	 * This method returns the session object containing the logged-in user's
	 * details.
	 * 
	 * @return
	 */
	public EmployeeDTO getCurrentUser() {
		if (employee == null) {
			boolean isLocalDevEnvironment = "local".equalsIgnoreCase(System.getProperty("MHV_ENV_PROPERTY").trim());
			boolean isIntBEnvironment = "intb".equalsIgnoreCase(System.getProperty("MHV_ENV_PROPERTY").trim());
			boolean issysBEnvironment = "sysb".equalsIgnoreCase(System.getProperty("MHV_ENV_PROPERTY").trim());
			
			if (isLocalDevEnvironment) {
				employee = this.getEmployee("vhaislegberb");
			}
			else if (isIntBEnvironment) {
				employee = this.getEmployee("vhaislgaganp");
			}
			else if (issysBEnvironment) {
				employee = this.getEmployee("vhaislgaganp");
			}			
			else {
				
				try {
					if (FacesContext.getCurrentInstance().getPartialViewContext().isAjaxRequest()) {
					}
					else {
						PortletRequest portalRequest = (PortletRequest) FacesContext.getCurrentInstance().getExternalContext().getRequest();
						HttpSession httpSession = PortalUtil.getHttpServletRequest(portalRequest).getSession();
						if (httpSession != null) {
							employee = (EmployeeDTO) httpSession.getAttribute("EMPLOYEE_DTO");
						}
					}
				} catch (Exception e) {
					log.error("Error in SessionUtil.getCurrentUser() while retrieving EmployeeDTO from Session.", e);
				}
			}
		}
		
		return employee;
	}
	
	public EmployeeDTO getEmployee(String userName) {
		EmployeeDTO emp = null;
		try {
			AdminUserService adminUserService = (AdminUserService) SpringContext.getApplicationContext().getBean("adminUserServiceProxy");
			emp = adminUserService.findEmployeeByUserName(userName);
		} catch (BeansException e) {
			FacesContext.getCurrentInstance().addMessage("Application Error.", new FacesMessage("Unexpected error."));
			log.error("Error in adminUserService.getEmployee()", e);
			throw e;
		} catch (MHVException e) {
			FacesContext.getCurrentInstance().addMessage("Application Error.", new FacesMessage("Unexpected error."));
			log.error("Error in adminUserService.getEmployee()", e);
		}
		return emp;
	}
	
}
