<%@ page import ="com.bea.p13n.entitlements.common.EntitlementConstants" %>
<%@ page import ="com.bea.p13n.entitlements.internal.PolicyRefIntegrity" %>
<%@ page import="org.owasp.esapi.*"%>
<!--
Policy Ref Integrity Checker Description:

This utility is useful if you have a concern about LDAP security policies being
out of sync with their corresponding data in RDBMS. Running this JSP will compare
and give a listing of policy information in LDAP and RDBMS and report on any
inconsistencies it can find. This utility is not necessary to run unless you
strongly suspect you have an issue. For example, if you are trying to create a
Role (DA or Visitor) or Security policy via the Portal Admin console, but are
unable to because you get a status "policy already exists". Another symptom of
LDAP/RDBMS being out of sync in a cluster is when two Portal Admin consoles (two
instances on different managed servers) report different policy information.

This utility works by listing policies from LDAP and then insuring corresponding
RDBMS data exists in the P13N_ENTITLEMENT_* tables. Then, the opposite is done to
cross check things.

Note: The initial version of this tool cannot initially list security policies from
LDAP (only role policies). Due to this it does not provide 100% integrity checking.

To use the PolicyChecker.jsp, it must be deployed into a webapp in the domain of
interest. It does not have to be deployed into the enterprise application of interest.
Of course it does rely on p13n libraries, so they must be accessible.

Once running, you can specify the enterprise application and web application names.
No actual policy attributes (user names, group names, expression attributes) will
be listed by this tool, but since it accesses policy information you must be in
an administrative Role to use it. To enable basic authentication prompts, add the
following information to the web.xml descriptor you deploy the JSP with.

====================================================================
        Add the following to the webApp web.xml you will deploy the PolicyChecker.jsp in.
        By default, all WLP domains will contain the Admin role and the
        security realm is 'myrealm'. Make any adjustments needed in web.xml.

        <security-constraint>
                <web-resource-collection>
                        <web-resource-name>policyChecker</web-resource-name>
                        <url-pattern>*.jsp</url-pattern>
                        <http-method>GET</http-method>
                        <http-method>POST</http-method>
                </web-resource-collection>
                <auth-constraint>
                        <role-name>Admin</role-name>
                </auth-constraint>
        </security-constraint>

        <login-config>
                <auth-method>BASIC</auth-method>
                <realm-name>myrealm</realm-name>
        </login-config>

====================================================================

Once deployed and run, PolicyChecker.jsp will generate a report listing the results
of the cross referencing policy checks. If there are any errors found, the string
"Errors WERE Found" will be seen. If you do see this error you should save the report
information, details about the environment it occurred in and work with your WLP
support engineer to evaluate the error. A first question will be to confirm patches
are in place that deal with any known policy integrity issues.

PolicyChecker.jsp support for release 9.2:

Some manual work is required for using this utility on release 9.2. The only new 10.0
product classes required are com.bea.p13n.entitlements.internal.PolicyRefIntegrity and
com.bea.p13n.entitlements.internal.RDBMSEntitlementRefDelegateExtension.  Those
classes do not utilize any other new product interfaces. To make these classes available,
you can either extract them from p13n_app.jar and deploy them within your web-inf/classes
directory or embed the classes inline in PolicyChecker.jsp making the appropriate changes.

-->
<%
   		// com.bea.p13n.security.Authentication.login("weblogic", "weblogic", request);
    	String appName = com.bea.p13n.management.ApplicationHelper.getApplicationName();
        String webName = com.bea.p13n.management.ApplicationHelper.getWebAppName(request);
        String [] webNames = com.bea.p13n.management.ApplicationHelper.getWebAppNames();



        String entAppName = ESAPI.encoder().encodeForHTML(request.getParameter("entAppName"));
        String webAppName = ESAPI.encoder().encodeForHTML(request.getParameter("webAppName"));

        appName = ((entAppName != null) && (entAppName.length() > 0)) ? entAppName : appName;
        webName = ((webAppName != null) && (webAppName.length() > 0)) ? webAppName : webName;
%>

<FORM action="PolicyChecker.jsp" method="post">
 <P>
 <FIELDSET>
  <LEGEND>Current Application</LEGEND><%=ESAPI.encoder().encodeForHTML(appName)%>
 </FIELDSET>
 <FIELDSET>
  <LEGEND>Current Web Applications</LEGEND>
    <%
     for (int i=0; i<webNames.length; i++)
     {
        response.getOutputStream().print(webNames[i] + "<br>");
     }
  %>
 </FIELDSET>

 <FIELDSET>
  <LEGEND>Target Application (leave empty for default app)</LEGEND>
  <label for="entAppName">Enterprise App Name: </label><INPUT id="entAppName" name="entAppName" type="text" value="<%=ESAPI.encoder().encodeForHTML(entAppName)%>" tabindex="1">
  <label for="webAppName">Web App Name: </label><INPUT id="webAppName" name="webAppName" type="text" value="<%=ESAPI.encoder().encodeForHTML(webAppName)%>" tabindex="2">
 </FIELDSET>
 <INPUT type="submit" value="Send">
</FORM>



<%
        %><br><br><h2><center>Checking LDAP and RDBMS Policy Integrity</h2><%
        %><br><br><h2><center>Enterprise application "<%=ESAPI.encoder().encodeForHTML(appName)%>"   Web application "<%=ESAPI.encoder().encodeForHTML(webName)%>".</h2><%

        %><br><br><hr><h3><em>(1) Query all roles in LDAP, and validate corresponding Policy Reference data...</em></h3><%
    boolean errors = PolicyRefIntegrity.validateLdapRolePolicies(appName, webName, EntitlementConstants.P13N_ROLE_POLICY_POOL,
        EntitlementConstants.HIERARCHICAL_ROLE_INHERITANCE, false, response);

    %><br><br><hr><h3><em>(2) Query Delegated Admin roles in LDAP, and validate corresponding Policy Reference data...</em></h3><%
    errors = PolicyRefIntegrity.validateLdapRolePolicies(appName, null, EntitlementConstants.P13N_ADMIN_ROLE_POLICY_POOL,
        EntitlementConstants.LEAF_NODE_ROLE_INHERITANCE, true, response);


        %><br><br><hr><h3><em>(3) Query Delegated Admin webapp-scoped policies in RDBMS, and validate corresponding policy in LDAP</em></h3><%
     errors = PolicyRefIntegrity.validatePolicyRefSecurityPolicies(true, appName, webName, response);

        %><br><br><hr><h3><em>(4) Query Delegated Admin entapp-scoped policies in RDBMS, and validate corresponding policy in LDAP</em></h3><%
     errors = PolicyRefIntegrity.validatePolicyRefSecurityPolicies(true, appName, null, response);


        %><br><br><hr><h3><em>(5) Query Visitor webapp-scoped security policies in RDBMS, and validate corresponding policy in LDAP</em></h3><%
    errors = PolicyRefIntegrity.validatePolicyRefSecurityPolicies(false, appName, webName, response);

        %><br><br><hr><h3><em>(6) Query Visitor entapp-scoped security policies in RDBMS, and validate corresponding policy in LDAP</em></h3><%
    errors = PolicyRefIntegrity.validatePolicyRefSecurityPolicies(false, appName, null, response);

        %><br><br><hr><h3><em>(7) Query Visitor webapp-scoped role policies in RDBMS, and validate corresponding policy in LDAP</em></h3><%
    errors = PolicyRefIntegrity.validatePolicyRefRolePolicies(false, appName, webName, response);

        %><br><br><hr><h3><em>(8) Query Visitor entapp-scoped role policies in RDBMS, and validate corresponding policy in LDAP</em></h3><%
    errors = PolicyRefIntegrity.validatePolicyRefRolePolicies(false, appName, null, response);

%>