package gov.va.med.mhv.calendar.repository;

import java.util.List;

import gov.va.med.mhv.calendar.model.UserCalView;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

public interface UserCalViewRepository extends JpaRepository<UserCalView, Long> {

	@Query("select view from UserCalView view " +
			   "where view.vhaReminders = 1 and view.visn.visnId = :visnId ")
	public List<UserCalView> getUsersForVhaReminderByVisn(@Param("visnId") Long visnId);
	

	@Query("select view from UserCalView view " +
			   "where view.userProfileId = :userProfileId ")
	public List<UserCalView> getUserCalViewForUser(@Param("userProfileId") Long userProfileId);
	
	
}
