package gov.va.med.mhv.health.web.util;

import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.ws.rs.core.Response;

import org.apache.cxf.jaxrs.client.WebClient;

import gov.va.med.mhv.common.api.exception.MHVException;

public class WebServiceClientUtil {
	private static final String ERR_PRCS_RQST="Error Processing request";

	
	public static String formatErrorMessage(WebClient client, Response webserviceResponse){
		   StringBuffer sb= new StringBuffer();
		   sb.append("Invlaid Response to webservice call").
		   append(",Webservice URL:").append(client.getCurrentURI()).
		   append(",Status code:").append( webserviceResponse.getStatusInfo().getStatusCode() ).
		   append(",Reason:").append( webserviceResponse.getStatusInfo().getReasonPhrase());
		   return sb.toString();
	}
	
	public static String formatErrorMessage(MHVException ex) {
		StringBuffer sb= new StringBuffer();
		   sb.append("Invlaid Response to webservice call").
		   append("Error code:").append( ex.getErrorCode() ).
		   append(",Reason:").append( ex.getFailureMessage());
		   return sb.toString();
	}
	
	
	public static void showErrorMessage(){
		FacesContext.getCurrentInstance().addMessage(null,
				new FacesMessage(FacesMessage.SEVERITY_ERROR,ERR_PRCS_RQST,ERR_PRCS_RQST));
	}
}
