/**
 * 
 */
package gov.va.med.mhv.liferay.saml.profile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.liferay.portal.kernel.exception.PortalException;
import com.liferay.saml.SamlSsoRequestContext;
import com.liferay.saml.profile.WebSsoProfileImpl;

import gov.va.med.mhv.liferay.saml.aal.AccountActivityClient;

/**
 * @author vhaislegberb
 *
 */
public class MhvWebSsoProfileImpl extends WebSsoProfileImpl {
	
	private static final String SESSION_USERPROFILE_ID = "LIFERAY_SHARED_userprofileid";
	private static final String SESSION_MHV_API_TOKEN = "LIFERAY_SHARED_api_token";
	private static final String AAL_ACTIVITY = "Login";
	private static final String AAL_ACTION = "Login for %s.";
	private static final String AAL_DETAIL_VALUE = "Signed in %s.";
	private static final String AAL_ACTOR = "Self";
	
	private AccountActivityClient aalClient = null;
	
	@Override
	protected void sendSuccessResponse(HttpServletRequest request, HttpServletResponse response,
			SamlSsoRequestContext samlSsoRequestContext) throws Exception {
		
		Long userProfileId = (Long)request.getSession().getAttribute(SESSION_USERPROFILE_ID);
		String apiToken = (String)request.getSession().getAttribute(SESSION_MHV_API_TOKEN);
		String entityId = samlSsoRequestContext.getSAMLMessageContext().getPeerEntityId();
		
		aalClient.createAccountActivity(userProfileId, AAL_ACTOR, true, AAL_ACTIVITY, String.format(AAL_ACTION, entityId), String.format(AAL_DETAIL_VALUE, entityId), apiToken);
		
		super.sendSuccessResponse(request, response, samlSsoRequestContext);
	}
	
	public void setAalClient(AccountActivityClient aalClient) {
		this.aalClient = aalClient;
	}

}
