package gov.va.med.mhv.mrp.util;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.TimeZone;

public class CommonUtility {
	
	public static String dateToString (Date date,String format){
		String stringDate=null;
		try{
			if(date != null){
			   SimpleDateFormat sdf = new SimpleDateFormat(format);
			   stringDate =sdf.format(date);
			}
		}catch(Exception e){
			throw new RuntimeException("Invalid Date format");
		}
		return stringDate;
	}
	
	public static String dateToStringTimeZone (Date date,String format){
		String stringDate="";
		try{
			if(date != null){
			   SimpleDateFormat sdf = new SimpleDateFormat(format);
			   sdf.setTimeZone(TimeZone.getTimeZone("America/New_York"));
			   stringDate =sdf.format(date);
			}
		}catch(Exception e){
			throw new RuntimeException("Invalid Date format");
		}
		return stringDate;
	}
	
	public static Date getDaTeTime(Date date,String hour, String minute){
		Integer intHour=0;
		Integer intMinute=0;
		if(hour != null){
		   intHour = Integer.parseInt(hour);	
		}
		if(minute != null){
		   intMinute = Integer.parseInt(minute);
		}
		Calendar cal =Calendar.getInstance();
		cal.setTime(date);
		cal.set(Calendar.HOUR_OF_DAY,intHour);
		cal.set(Calendar.MINUTE,intMinute);
		cal.set(Calendar.SECOND, 0);
		cal.set(Calendar.MILLISECOND,0);
		return cal.getTime();
	}
	
	public static int dateToInt (Date date,String format){
		int intDate=0;
		try{
			if(date != null){
			   SimpleDateFormat sdf = new SimpleDateFormat(format);
			   intDate =Integer.parseInt(sdf.format(date));
			}
		}catch(Exception e){
			throw new RuntimeException("Invalid Date format");
		}
		return intDate;
	}

}
