package gov.va.med.mhv.rxrefill.batch.jms;

import javax.jms.JMSException;
import javax.jms.Message;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.jms.core.JmsTemplate;
import org.springframework.jms.core.MessagePostProcessor;
import org.springframework.stereotype.Component;

import gov.va.med.mhv.common.api.exception.MHVException;



public class RxRefillVistaRefreshClient {

	protected static final Logger LOGGER = LogManager.getLogger(RxRefillVistaRefreshClient.class);
	
	
	@Autowired
	private JmsTemplate jmsTemplate;
	
	
	public void refreshHistoricalPrescriptions(Long  userProfileId) throws MHVException {
		
		try {
			this.jmsTemplate.convertAndSend(userProfileId, new MessagePostProcessor() {
				
				@Override
				public Message postProcessMessage(Message message) throws JMSException {
					message.setStringProperty("JavaType", "Long");
					return message;
				}
			});
		} catch ( Exception ex ) {
			String message = "Error sending refrsh rxrefill VistA Asynchronously.";
			LOGGER.error(message);
			throw new MHVException(message, ex);
		}
		
	}

}
