package gov.va.med.mhv.rxrefill.batch.processor;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.batch.item.ItemProcessor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Component;

import gov.va.med.mhv.common.api.exception.MHVException;
import gov.va.med.mhv.rxrefill.service.PharmacyRefillWebService;

@Component("vistaRefreshProcessor")
public class VistaRefreshProcessor implements ItemProcessor<Long, Long> {

	private static final Logger logger = LogManager.getLogger(VistaRefreshProcessor.class);
	
	@Autowired
	@Qualifier("rxRefillWebService")
	private PharmacyRefillWebService pharmacyRefillWebService;
	
	@Override
	public Long process(Long userprofileId) throws Exception {
		doRxTrackingVistaRefreshForUser(userprofileId);
		return userprofileId;
	}
	
	private void doRxTrackingVistaRefreshForUser(Long userprofileId) {
	   try {
		    pharmacyRefillWebService.refreshHistoricalPrescriptions(userprofileId);
	   } catch (MHVException e) {
		   logger.error("Rx Tracking Vista refresh Error for the User::"+ userprofileId,e);
	   }
	}
}