package gov.va.med.mhv.rxrefill.batch.writer;

import java.util.List;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.batch.item.ItemWriter;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Component;

import gov.va.med.mhv.rxrefill.data.model.UserProfileEmailInfo;

@Component("emailTrackingWriter")
public class EmailTrackingWriter implements ItemWriter<UserProfileEmailInfo> {
	private static final String PATIENT_UPDATE_QUERY="update patient set EMAIL_TRCKG_DT= sysdate where USER_PROFILE_USER_PROFILE_ID  = ? ";
	
	private static final Logger logger = LogManager.getLogger(EmailTrackingWriter.class);
	
	@Autowired
	protected JdbcTemplate evaultJdbcTemplate;
	
	@Override
	public void write(List<? extends UserProfileEmailInfo> items) throws Exception {
		for(UserProfileEmailInfo userProfileEmailInfo :items){
			
			evaultJdbcTemplate.update(PATIENT_UPDATE_QUERY, new Object[]{userProfileEmailInfo.getUserprofileId()});
		}
	}
	
}
