package gov.va.med.mhv.rxrefill.batch.writer;

import java.util.List;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.batch.item.ItemWriter;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Component;

@Component("vistaRefreshwriter")
public class VistaRefreshItemWriter implements ItemWriter<Long> {
	
	@Autowired
	protected JdbcTemplate evaultJdbcTemplate;
	
	private static final String PATIENT_UPDATE_QUERY="update patient set vista_refresh_dt= sysdate where USER_PROFILE_USER_PROFILE_ID  = ? ";
	
	private static final Logger logger = LogManager.getLogger(VistaRefreshItemWriter.class);
	

	@Override
	public void write(List<? extends Long> items) throws Exception {
		
		for(Long userprofileId :items){
			evaultJdbcTemplate.update(PATIENT_UPDATE_QUERY, new Object[]{userprofileId});
		}
		
	}
}
