package gov.va.med.mhv.usermgmt.batch.jdbc;

import java.sql.ResultSet;
import java.sql.SQLException;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Component;

import gov.va.med.mhv.common.data.model.Patient;
import gov.va.med.mhv.usermgmt.data.repository.PatientRepository;

@Component
public class PatientIdMaterializedViewMapper implements RowMapper<Patient> {
	
	@Autowired
	private PatientRepository patientRepository;
	
	@Override
	public Patient mapRow(ResultSet rs, int rowNum) throws SQLException {
		Long patientId = rs.getLong("ITEM_ID");
		return patientRepository.findOne(patientId);
	}
	
}
