package gov.va.med.mhv.usermgmt.tasklet;

import java.util.Map;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.batch.core.StepContribution;
import org.springframework.batch.core.scope.context.ChunkContext;
import org.springframework.batch.core.step.tasklet.Tasklet;
import org.springframework.batch.repeat.RepeatStatus;

public class SimpleLoggingTasklet implements Tasklet {
	
	private static final Logger logger = LogManager.getLogger(SimpleLoggingTasklet.class);
	
	private static final String MESSAGE = "TASKLET REPEAT: %d";

	/* (non-Javadoc)
	 * @see org.springframework.batch.core.step.tasklet.Tasklet#execute(org.springframework.batch.core.StepContribution, org.springframework.batch.core.scope.context.ChunkContext)
	 */
	@Override
	public RepeatStatus execute(StepContribution contribution, ChunkContext chunkContext) throws Exception {
		
		Map<String, Object> params = chunkContext.getStepContext().getJobParameters();
		Long iterate = (Long)Long.valueOf((String)params.get("ITERATE"));
		
		logger.info(String.format("Tasklet: %s starting with parameter ITERATE=%d.", SimpleLoggingTasklet.class.getSimpleName(), iterate));
		
		for(int i = 0; i < iterate; i++) {
			logger.info(String.format(MESSAGE, i));
		}
		
		logger.info(String.format("Tasklet: %s completed.", SimpleLoggingTasklet.class.getSimpleName()));
		
		return RepeatStatus.FINISHED;
	}

}
