package gov.va.med.mhv.usermgmt.util;

import java.text.SimpleDateFormat;

import org.springframework.stereotype.Component;

import gov.va.med.mhv.common.data.model.Patient;

@Component
public class DetermineMatchCounter {
	
	public int determineMatchCounter(Patient patient, Patient mviPatient) {
    	int matchCounter = 0;
    	boolean firstNameMatch = false;
    	if(mviPatient.getUserProfile().getFirstName() != null && patient.getUserProfile().getFirstName() != null) {
    		firstNameMatch = mviPatient.getUserProfile().getFirstName().toUpperCase().equals(patient.getUserProfile().getFirstName().toUpperCase()) ? true : false;
    	}
		boolean lastNameMatch = false;
		if(mviPatient.getUserProfile().getLastName() != null && patient.getUserProfile().getLastName() != null) {
			lastNameMatch = mviPatient.getUserProfile().getLastName().toUpperCase().equals(patient.getUserProfile().getLastName().toUpperCase()) ? true : false;
		}
		boolean middleNameMatch = false;
		if(mviPatient.getUserProfile().getMiddleName() != null && patient.getUserProfile().getMiddleName() != null) {
			middleNameMatch = mviPatient.getUserProfile().getMiddleName().toUpperCase().equals(patient.getUserProfile().getMiddleName().toUpperCase()) ? true : false;
		} else if(mviPatient.getUserProfile().getMiddleName() ==  null && patient.getUserProfile().getMiddleName() == null) {
			middleNameMatch = true;
		}
		boolean genderMatch = false;
		if(mviPatient.getUserProfile().getGender() != null && patient.getUserProfile().getGender() != null) {
			genderMatch = mviPatient.getUserProfile().getGender().equals(patient.getUserProfile().getGender()) ? true : false;
		} else if(mviPatient.getUserProfile().getGender() == null && patient.getUserProfile().getGender() == null) {
			genderMatch = true;
		}
		boolean birthdateMatch = false;
		if(mviPatient.getUserProfile().getBirthDate() != null && patient.getUserProfile().getBirthDate() != null) {
			SimpleDateFormat sdf = new SimpleDateFormat("MM-dd-yyyy");
			String mviPatientBirthDate = sdf.format(mviPatient.getUserProfile().getBirthDate());
			String patientBirthDate = sdf.format(patient.getUserProfile().getBirthDate());
			birthdateMatch = mviPatientBirthDate.equals(patientBirthDate) ? true : false;
		}
		boolean ssnMatch = false;
		if(mviPatient.getUserProfile().getSsn() != null && patient.getUserProfile().getSsn() != null) {
			String patientSSN = patient.getUserProfile().getSsn().replace("-", "");
			ssnMatch = mviPatient.getUserProfile().getSsn().equals(patientSSN) ? true : false;
		}
		boolean icnMatch = false;
		if(mviPatient.getIcn() != null && patient.getIcn() != null) {
			icnMatch = mviPatient.getIcn().equals(patient.getIcn()) ? true : false;
		}
		matchCounter = firstNameMatch ? ++matchCounter : matchCounter;
		matchCounter = lastNameMatch ? ++matchCounter : matchCounter;
		matchCounter = middleNameMatch ? ++matchCounter : matchCounter;
		matchCounter = genderMatch ? ++matchCounter : matchCounter;
		matchCounter = birthdateMatch ? ++matchCounter : matchCounter;
		matchCounter = ssnMatch ? ++matchCounter : matchCounter;
		matchCounter = icnMatch ? ++matchCounter : matchCounter;
    	return matchCounter;
    }
}