package gov.va.med.mhv.usermgmt.util;

import java.io.FileWriter;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class FileWriterUtil {
	private static final Logger logger = LogManager.getLogger(FileWriterUtil.class);
	
	private FileWriter fw = null;
	private String fileName;

	public void create(String filename, Date fileDate) {
    	
    	try {
        	SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd_HH-mm-ss");

        	fileName = filename + sdf.format(fileDate) + ".txt";
        	
        	if (fw != null) {
        		fw.close();
        	}
        	
			fw = new FileWriter(fileName, true);

		} catch (Exception e) {
			logger.error("Could not create log file='" + fileName + "' ", e);
		} finally {
			close();
		}		
	}
	
	public void close() {
		try {
			if (fw != null) {
				fw.close();
				fw = null;
			}
		} catch (Exception e) {
			logger.error("Could not close log file='" + fileName + "' ", e);
		}
	}
	
	public void write(String s) {
		try {
			if (fw != null) {
				fw.write(s);
			}
		} catch (Exception e) {
			if (logger.isDebugEnabled()) {
				logger.debug("Could not write to log file='" + fileName + "' ", e);
			}
		}

	}

	public FileWriter getFileWriter() {
		return fw;
	}

	public String getFileName() {
		return fileName;
	}
	
	
}
