package gov.va.med.mhv.usermgmt.util;

import org.springframework.util.StopWatch;
import org.springframework.util.StopWatch.TaskInfo;

public class JobTiming {
	
	private StopWatch stopWatch = new StopWatch();

	public double getMinTimeSeconds() {
		TaskInfo[] tasks = stopWatch.getTaskInfo();
		double time = 0;
		
		for (TaskInfo ti : tasks) {
			time = Math.min(time, ti.getTimeSeconds());
		}
		return time;
	}
	
	public double getMaxTimeSeconds() {
		TaskInfo[] tasks = stopWatch.getTaskInfo();
		double time = 0;
		
		for (TaskInfo ti : tasks) {
			time = Math.max(time, ti.getTimeSeconds());
		}
		return time;
	}
	
	public double getMeanTimeSeconds() {
		if (stopWatch.getTaskCount() <= 0) {
			return 0;
		} else {
			return stopWatch.getTotalTimeSeconds() / stopWatch.getTaskCount();
		}
	}

	public void reset() {
		stopWatch = new StopWatch();
	}
	
	public String getSummary() {
		return String.format("%s, Min %.2f, Max %.2f, Mean %.2f", stopWatch.shortSummary(),
				getMinTimeSeconds(), getMaxTimeSeconds(), getMeanTimeSeconds());
	}

	public StopWatch getStopWatch() {
		return stopWatch;
	}

}
