package gov.va.med.mhv.core.validate;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.commons.lang3.StringUtils;

public class SSNValidator /*extends SinglePropertyValidator*/ {

	private static final Pattern[] PATTERNS;
	
	static {
		PATTERNS = new Pattern[] {Pattern.compile("^[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]$"),
				                  Pattern.compile("^[0-9][0-9][0-9]-[0-9][0-9]-[0-9][0-9][0-9][0-9]$")};
	}
	
	public static boolean isValid(String ssn) {
		//String ssn = null;
/*		try {
			ssn = (String) value;
		} catch (ClassCastException cce) {
			return false;
		}*/
		
		if (StringUtils.isNotBlank(ssn)) {
			for (int i=0; i<PATTERNS.length; i++) {
				Matcher m = PATTERNS[i].matcher(ssn);
				if (m.matches()) {
					return true;
				}
			}
		}
		return false;
	}

/*	protected String getMessageKey() {
		return "invalid.ssn";
	}
	*/

}
