package gov.va.med.mhv.usermgmt.data.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;

import org.hibernate.annotations.Type;

@Entity
@Table(name="EMERGENCY_CONTACT")
public class EmergencyContact {

	@Id
	@Column(name = "EMERGENCY_CONTACT_ID")
	@GeneratedValue(strategy = GenerationType.AUTO)
	private Long emergencyContactId;
	
	@Column(name = "OPLOCK")
	private Integer oplock = new Integer(0);
	
	@Column(name = "ADDRESS_STREET_1")
	private String addressStreet1;
	
	@Column(name = "TITLE")
	private String title;
	
	@Column(name = "CONTACT_INFO_EMAIL")
	private String email;
	
	@Column(name = "ADDRESS_PROVINCE")
	private String province;
	
	@Column(name = "ADDRESS_STATE")
	private String state;
	
	@Column(name = "CONTACT_INFO_WORK_PHONE_EXT")
	private String workPhoneExt;
	
	@Column(name = "RELATIONSHIP")
	private String relationship;
	
	@Column(name = "FIRST_NAME")
	private String firstName;
	
	@Column(name = "ADDRESS_STREET_2")
	private String addressStreet2;
	
	@Column(name = "LAST_NAME")
	private String lastName;
	
	@Column(name = "ADDRESS_POSTAL_CODE")
	private String postalCode;
	
	@Column(name = "ADDRESS_COUNTRY")
	private String country;
	
	@Column(name = "ADDRESS_CITY")
	private String city;
	
	@Column(name = "SUFFIX")
	private String suffix;
	
	@Column(name = "CONTACT_INFO_HOME_PHONE")
	private String homePhone;
	
	@Column(name = "CONTACT_INFO_CONTACT_METHOD")
	private String contactMethod;
	
	@Column(name = "CONTACT_INFO_MOBILE_PHONE")
	private String mobilePhone;
	
	@Column(name = "MIDDLE_NAME")
	private String middleName;
	
	@Column(name = "CONTACT_INFO_WORK_PHONE")
	private String workPhone;
	
	@Column(name = "CONTACT_INFO_PAGER")
	private String pager;
	
	@Column(name = "PRIORITY")
	private Integer priority;
	
	@Column(name = "CONTACT_INFO_FAX")
	private String fax;
	
	@Column(name = "USER_PROFILE_ID")
	private Long userProfileId;
	
	@Column(name = "IS_PRIMARY", columnDefinition = "NUMBER")
	@Type(type = "org.hibernate.type.NumericBooleanType")
	private Boolean primary;

	public Long getEmergencyContactId() {
		return emergencyContactId;
	}

	public void setEmergencyContactId(Long emergencyContactId) {
		this.emergencyContactId = emergencyContactId;
	}

	public Integer getOplock() {
		return oplock;
	}

	public void setOplock(Integer oplock) {
		this.oplock = oplock;
	}

	public String getAddressStreet1() {
		return addressStreet1;
	}

	public void setAddressStreet1(String addressStreet1) {
		this.addressStreet1 = addressStreet1;
	}

	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getProvince() {
		return province;
	}

	public void setProvince(String province) {
		this.province = province;
	}

	public String getState() {
		return state;
	}

	public void setState(String state) {
		this.state = state;
	}

	public String getWorkPhoneExt() {
		return workPhoneExt;
	}

	public void setWorkPhoneExt(String workPhoneExt) {
		this.workPhoneExt = workPhoneExt;
	}

	public String getRelationship() {
		return relationship;
	}

	public void setRelationship(String relationship) {
		this.relationship = relationship;
	}

	public String getFirstName() {
		return firstName;
	}

	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}

	public String getAddressStreet2() {
		return addressStreet2;
	}

	public void setAddressStreet2(String addressStreet2) {
		this.addressStreet2 = addressStreet2;
	}

	public String getLastName() {
		return lastName;
	}

	public void setLastName(String lastName) {
		this.lastName = lastName;
	}

	public String getPostalCode() {
		return postalCode;
	}

	public void setPostalCode(String postalCode) {
		this.postalCode = postalCode;
	}

	public String getCountry() {
		return country;
	}

	public void setCountry(String country) {
		this.country = country;
	}

	public String getCity() {
		return city;
	}

	public void setCity(String city) {
		this.city = city;
	}

	public String getSuffix() {
		return suffix;
	}

	public void setSuffix(String suffix) {
		this.suffix = suffix;
	}

	public String getHomePhone() {
		return homePhone;
	}

	public void setHomePhone(String homePhone) {
		this.homePhone = homePhone;
	}

	public String getContactMethod() {
		return contactMethod;
	}

	public void setContactMethod(String contactMethod) {
		this.contactMethod = contactMethod;
	}

	public String getMobilePhone() {
		return mobilePhone;
	}

	public void setMobilePhone(String mobilePhone) {
		this.mobilePhone = mobilePhone;
	}

	public String getMiddleName() {
		return middleName;
	}

	public void setMiddleName(String middleName) {
		this.middleName = middleName;
	}

	public String getWorkPhone() {
		return workPhone;
	}

	public void setWorkPhone(String workPhone) {
		this.workPhone = workPhone;
	}

	public String getPager() {
		return pager;
	}

	public void setPager(String pager) {
		this.pager = pager;
	}

	public Integer getPriority() {
		return priority;
	}

	public void setPriority(Integer priority) {
		this.priority = priority;
	}

	public String getFax() {
		return fax;
	}

	public void setFax(String fax) {
		this.fax = fax;
	}

	public Long getUserProfileId() {
		return userProfileId;
	}

	public void setUserProfileId(Long userProfileId) {
		this.userProfileId = userProfileId;
	}

	public Boolean isPrimary() {
		return primary;
	}

	public void setPrimary(Boolean primary) {
		this.primary = primary;
	}
}
