package gov.va.med.mhv.usermgmt.essapi.transfer;

import java.io.Serializable;

import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement(name = "Register")
public class RegisterTO implements Serializable{
	
	
	private static final long serialVersionUID = -5092766816275256518L;
	
	private String firstName;
	private String middleName;
	private String lastName;
	private String sSN;
	private String birthDate;
	private String gender;
	
	private String icn;
	
	//Relationship to VA
	private Boolean isPatient;
	private Boolean isPatientAdvocate;
	private Boolean isVeteran;
	private Boolean isChampVABeneficiary;
	private Boolean isServiceMemeber;
	private Boolean isEmployee;
	private Boolean isHealthCareProvider;
	private Boolean isOther;
	
	//Primary Address
	private String city;
	private String country;
	private String zip;
	private String province;
	private String state;
	private String address1;
	private String address2;
	
	//Prefer Contact Method
	private String contactMethod;
	private String email;
	private String fax;
	private String homePhone;
	private String mobilePhone;
	private String pager;
	private String workPhone;
	
	//Client id for SIP
	private String signInPartners;
	
	//External Terms and Conditions
	private String termsVersion;
	private String termsAcceptedDate;
	
	public String getFirstName() {
		return firstName;
	}
	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}
	public String getLastName() {
		return lastName;
	}
	public void setLastName(String lastName) {
		this.lastName = lastName;
	}
	public String getsSN() {
		return sSN;
	}
	public void setsSN(String sSN) {
		this.sSN = sSN;
	}
	public String getBirthDate() {
		return birthDate;
	}
	public void setBirthDate(String birthDate) {
		this.birthDate = birthDate;
	}
	public String getGender() {
		return gender;
	}
	public void setGender(String gender) {
		this.gender = gender;
	}
	public Boolean getIsPatient() {
		return isPatient;
	}
	public void setIsPatient(Boolean isPatient) {
		this.isPatient = isPatient;
	}
	public Boolean getIsPatientAdvocate() {
		return isPatientAdvocate;
	}
	public void setIsPatientAdvocate(Boolean isPatientAdvocate) {
		this.isPatientAdvocate = isPatientAdvocate;
	}
	public Boolean getIsVeteran() {
		return isVeteran;
	}
	public void setIsVeteran(Boolean isVeteran) {
		this.isVeteran = isVeteran;
	}
	public Boolean getIsChampVABeneficiary() {
		return isChampVABeneficiary;
	}
	public void setIsChampVABeneficiary(Boolean isChampVABeneficiary) {
		this.isChampVABeneficiary = isChampVABeneficiary;
	}
	public Boolean getIsServiceMemeber() {
		return isServiceMemeber;
	}
	public void setIsServiceMemeber(Boolean isServiceMemeber) {
		this.isServiceMemeber = isServiceMemeber;
	}
	public Boolean getIsEmployee() {
		return isEmployee;
	}
	public void setIsEmployee(Boolean isEmployee) {
		this.isEmployee = isEmployee;
	}
	public Boolean getIsHealthCareProvider() {
		return isHealthCareProvider;
	}
	public void setIsHealthCareProvider(Boolean isHealthCareProvider) {
		this.isHealthCareProvider = isHealthCareProvider;
	}
	public Boolean getIsOther() {
		return isOther;
	}
	public void setIsOther(Boolean isOther) {
		this.isOther = isOther;
	}
	public String getCity() {
		return city;
	}
	public void setCity(String city) {
		this.city = city;
	}
	public String getCountry() {
		return country;
	}
	public void setCountry(String country) {
		this.country = country;
	}
	public String getZip() {
		return zip;
	}
	public void setZip(String zip) {
		this.zip = zip;
	}
	public String getProvince() {
		return province;
	}
	public void setProvince(String province) {
		this.province = province;
	}
	public String getState() {
		return state;
	}
	public void setState(String state) {
		this.state = state;
	}
	public String getAddress1() {
		return address1;
	}
	public void setAddress1(String address1) {
		this.address1 = address1;
	}
	public String getAddress2() {
		return address2;
	}
	public void setAddress2(String address2) {
		this.address2 = address2;
	}
	public String getMiddleName() {
		return middleName;
	}
	public void setMiddleName(String middleName) {
		this.middleName = middleName;
	}
	public String getContactMethod() {
		return contactMethod;
	}
	public void setContactMethod(String contactMethod) {
		this.contactMethod = contactMethod;
	}
	public String getEmail() {
		return email;
	}
	public void setEmail(String email) {
		this.email = email;
	}
	public String getFax() {
		return fax;
	}
	public void setFax(String fax) {
		this.fax = fax;
	}
	public String getHomePhone() {
		return homePhone;
	}
	public void setHomePhone(String homePhone) {
		this.homePhone = homePhone;
	}
	public String getMobilePhone() {
		return mobilePhone;
	}
	public void setMobilePhone(String mobilePhone) {
		this.mobilePhone = mobilePhone;
	}
	public String getPager() {
		return pager;
	}
	public void setPager(String pager) {
		this.pager = pager;
	}
	public String getWorkPhone() {
		return workPhone;
	}
	public void setWorkPhone(String workPhone) {
		this.workPhone = workPhone;
	}
	public String getIcn() {
		return icn;
	}
	public void setIcn(String icn) {
		this.icn = icn;
	}
	public String getSignInPartners() {
		return signInPartners;
	}
	public void setSignInPartners(String signInPartners) {
		this.signInPartners = signInPartners;
	}
	public String getTermsVersion() {
		return termsVersion;
	}
	public void setTermsVersion(String termsVersion) {
		this.termsVersion = termsVersion;
	}
	public String getTermsAcceptedDate() {
		return termsAcceptedDate;
	}
	public void setTermsAcceptedDate(String termsAcceptedDate) {
		this.termsAcceptedDate = termsAcceptedDate;
	}
	


}
