package gov.va.med.mhv.usermgmt.web.controller;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

public interface EauthConstants {
	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String HASH_PARAM = "va_eauth_hash";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String CSID_PARAM = "va_eauth_csid";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String BIRTH_DATE = "va_eauth_birthdate_v1";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String FIRST_NAME = "va_eauth_firstname";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String MIDDLE_NAME = "va_eauth_middleName";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String LAST_NAME = "va_eauth_lastname";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String ID = "va_eauth_pnid";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String ID_TYPE = "va_eauth_pnidtype";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String GENDER = "va_eauth_gender";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String DEEP_LINK = "va_eauth_deep_link";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String DEEP_LINK_ATTR = "deepLink";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String CSID_ATTR = "eauthCsid";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String REALM_NAME = "myrealm";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String HASH_ATTR = "eauthHash";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String EAUTH_PORTAL = "eauth.portal";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String MHV_PORTAL = "/mhvPortal/mhv.portal";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String LOGIN_TYPE = "loginType";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String EAUTH = "eauth";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String EAUTH_ERROR = "eauthError";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String EDIPI_PARAM = "va_eauth_dodEdiPnId";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String VA_EAUTH_ASSUR_LEVEL = "va_eauth_assuranceLevel";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String ICN_PARAM = "va_eauth_icn";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String ADDRESS1 = "va_eauth_street";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String CITY = "va_eauth_city";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String STATE = "va_eauth_state";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String POSTAL_CODE = "va_eauth_postalcode";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String COUNTRY = "va_eauth_country";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String EMAIL = "va_eauth_email";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String PHONE = "va_eauth_phone";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String USER_PROFILE_ID = "va_eauth_mhvien";

	// Field descriptor #4 Ljava/lang/String;
	public static final java.lang.String CSP_ONLY = "va_eauth_csponly";

	public static final java.lang.String EMAIL_ADDRESS = "va_eauth_emailaddress";
	public static final java.lang.String VA_EAUTH_IS_DELEGATE = "va_eauth_isdelegate";
	public static final java.lang.String VA_EAUTH_IS_DELEGATE_CUSTOM = "va_eauth_isdelegate_custom";

	public static final String A_INVALID_ASSURANCE_LEVEL_MSG = "[A1]: Invalid VA Eauth Assurance Level";
	public static final String A_EMPTY_CSID_MSG = "[A2]: CSID is empty";
	public static final String A_ORC_LOGON = "[A3]: ORC Logon is not allowed";
	public static final String C_NOT_FOUND_ERROR_MSG = "[C4]: NOT_FOUND on first name, last name birth date or ssn";
	public static final String O_NOT_FOUND_ERROR_MSG = "[E4]: NOT_FOUND on first name, last name birth date or ssn";
	public static final String F_NOT_FOUND_ERROR_MSG = "[F4]: NOT_FOUND on first name, last name birth date or ssn";
	public static final String C_INVALID_SSN_MSG = "[C5]: Invalid SSN";
	//public static final String MULTIPLE_ACCOUNT_ERROR_MSG = "Multiple Account Error";
	public static final String O_DEACTIVATED_ACCOUNT_MSG = "O17: Deactivated Account";
	//public static final String EMPTY_ASSURANCE_LEVEL_MSG = "Empty VA Eauth Assurance Level";
	public static final String A_INVALID_HASH_MSG = "[A18]: Invalid Hash";
	//public static final String INVALID_SSN_MSG = "Invalid SSN";
	//public static final String SSN_MISMATCH_MSG = "SSN Mismatch";
	//public static final String INVALID_DOB_MSG = "Invalid Birth Date";
	public static final String O_INVALID_ICN_MSG = "O7: Invalid ICN";
	public static final String O_MULTIPLE_IDS_ERROR = "E10: Multiple IDs Error";
	public static final String C_MULTIPLE_IDS_ERROR = "[C10]: Multiple IDs Error";
	public static final String O_MVI_ERROR = "E9: Error message from MVI: ";
	public static final String C_MVI_ERROR = "[C6]: Error message from MVI: ";
	public static final String C_ACCOUNT_CONNECTION_ERROR = "[C8]: Your account cannot be connected at this time as the system cannot process your request"; // added for 2016.4
	public static final String C_UNRECOVERABLE_ERROR = "[C15]: Unrecoverable Error";
	public static final String C_INVALID_EDIPI = "[C13]: Invalid EDIPI";
	//public static final String C_MULTIPLE_EDIPIS = "C12: Multiple EDIPIs";  //commented out 9/12/16 in favor of following line from 2016.4
	public static final String C_MULTIPLE_EDIPIS = "[C10]: Multiple IDs Error";
	//public static final String C_MVI_ERROR = "[C9]:Error message from MVI:"; // added for 2016.4
	
	public static final String O_INVALID_SSN_MSG = "O5: Invalid SSN";
	public static final String O_INVALID_DOB_MSG = "O6: Invalid Birth Date";
	public static final String O_SSN_MISMATCH_MSG = "O11: SSN Mismatch";
	public static final String O_PENDING_CORR_MSG = "O20: Pending Uncorrelation or Failed Correlation Status";
	public static final String C_INVALID_DOB_MSG = "[C6]: Invalid Birth Date";
	public static final String C_SSN_MISMATCH_MSG = "[C11]: SSN Mismatch";
	public static final String C_INVALID_ICN_MSG = "[C7]: Invalid ICN";
	public static final String F_UNRECOVERABLE_ERROR = "[F15]: Unrecoverable Error";
	public static final String F_MULTIPLE_EDIPIS = "F12: Multiple EDIPIs";
	public static final String F_INVALID_SSN_MSG = "[F5]: Invalid SSN";
	public static final String F_INVALID_DOB_MSG = "[F6]: Invalid Birth Date";
	public static final String F_INVALID_ICN_MSG = "[F7]: Invalid ICN"; // added for 2016.4
	public static final String F_ACCOUNT_CONNECTION_ERROR = "[F8]: Your account cannot be connected at this time as the system cannot process your request"; // added for 2016.4
	public static final String F_SSN_MISMATCH_MSG = "[F11]: SSN Mismatch";
	public static final String F_MULTIPLE_IDS_ERROR = "[F10]: Multiple IDs Error";
	public static final String F_MULTIPLE_IENS_ERROR = "[F14]: Multiple Account Error"; // added for 2016.4
	public static final String F_MVI_ERROR = "[F9]: Error message from MVI: "; // added for 2016.4
	public static final String A_4_OR_MORE_TRAITS_UPDATE = "A21: Four or More Traits update";
	public static final String A_PATIENT_REC_CANNOT_BE_CREATED = "A22: Patient Record cannot be created";
}
