package gov.va.med.mhv.usermgmt.web.controller;

import java.sql.Timestamp;

import javax.annotation.Resource;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.context.FacesContext;
import javax.faces.event.ComponentSystemEvent;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import gov.va.med.mhv.common.api.exception.MHVException;
import gov.va.med.mhv.usermgmt.common.dto.ActivityDTO;
import gov.va.med.mhv.usermgmt.common.enums.ActivityActionTypeEnumeration;
import gov.va.med.mhv.usermgmt.common.enums.ActivityTypeEnumeration;
import gov.va.med.mhv.usermgmt.service.AccountActivityLogService;

@ManagedBean
@Component
@Scope("session")
public class VlerHealthAuthController  extends AbstractController{
	
	private static final long serialVersionUID = 6889094990111312538L;
	private static Logger log = LogManager.getLogger(VlerHealthAuthController.class);
	
	@Resource(name = "accountActivityProxy")
	private AccountActivityLogService accountActivityService;
	
	String vapiiFormStatus=null;
	public void init(ComponentSystemEvent event){
		try {
			vapiiFormStatus=null;
			if(getUserProfileId() != null){
				vapiiFormStatus= accountValidatorService.getVapiiFormStatusForUser(getUserProfileId());
				if(vapiiFormStatus == null || vapiiFormStatus.trim().length() == 0 ){
				   vapiiFormStatus="successfulcall";
				}
				createActitivyForVARecordAccess(getUserProfileId(),true);
			}
			log.debug("Vapii Form Status::");
			log.debug(vapiiFormStatus);
		} catch (MHVException e) {
			log.error("VaapiFormStatuserror::",e);
			try {
				createActitivyForVARecordAccess(getUserProfileId(),false);
			} catch (MHVException e1) {
				log.error("Failed to Create Failed Activity Log for connect to my Docs::",e1);
			}
			FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Error", "Error"));
		}
	}
	
	private void createActitivyForVARecordAccess(Long userProfileId,Boolean activityStatus) throws MHVException{
		ActivityDTO activity = new  ActivityDTO();
		activity.setAction(ActivityActionTypeEnumeration.SET_ADJUST_MY_PREFERENCES_SHARING.getDescription());
		activity.setActivityType(ActivityTypeEnumeration.MANAGE_VA_RECORD_ACCESS.getDescription());
		activity.setCompletionTime(new Timestamp(System.currentTimeMillis()));
		activity.setPerformerType("Self");
		activity.setStatus(activityStatus);
		activity.setUserProfileId(userProfileId);
		accountActivityService.createAccountActivityLog(activity);
	}
	
	public String getVappiFormStatus(){
		return vapiiFormStatus;
	}

}
