package gov.va.med.mhv.usermgmt.web.formbean;

import java.io.Serializable;

public class CareGiver implements Serializable {
	private static final long serialVersionUID = 7534137358301334991L;

	private Long careGiverId;
	private String firstName;
	private String lastName;
	private String providerType; //Primary, Specialist, Dentist, Eye, Other Clinician
	private String otherClinician;
	private String workPhone;
	private String workPhoneExt;
	private String emailAddress;
	private String comments;
	private Long userProfileId;
	
	public Long getCareGiverId() {
		return careGiverId;
	}
	public void setCareGiverId(Long careGiverId) {
		this.careGiverId = careGiverId;
	}
	public String getFirstName() {
		return firstName;
	}
	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}
	public String getFullName() {
		String fullName = "";
		if( this.firstName != null )
			fullName = fullName + this.firstName;
		
		if( lastName != null )
			fullName = fullName + " " + this.lastName;
		return fullName;
	}
	
	public String getFullPhoneNumber() {
		String full = "";
		if( this.workPhone != null )
			full = full + this.workPhone;
		
		if( this.workPhoneExt != null )
			full = full + this.workPhoneExt;
		
		return full;
	}

	public String getLastName() {
		return lastName;
	}
	public void setLastName(String lastName) {
		this.lastName = lastName;
	}
	public String getProviderType() {
		return providerType;
	}
	public void setProviderType(String providerType) {
		this.providerType = providerType;
	}
	public String getOtherClinician() {
		return otherClinician;
	}
	public void setOtherClinician(String otherClinician) {
		this.otherClinician = otherClinician;
	}

	public String getWorkPhone() {
		return workPhone;
	}
	public void setWorkPhone(String workPhone) {
		this.workPhone = workPhone;
	}
	public String getWorkPhoneExt() {
		return workPhoneExt;
	}
	public void setWorkPhoneExt(String workPhoneExt) {
		this.workPhoneExt = workPhoneExt;
	}
	public String getEmailAddress() {
		return emailAddress;
	}
	public void setEmailAddress(String emailAddress) {
		this.emailAddress = emailAddress;
	}
	public String getComments() {
		return comments;
	}
	public void setComments(String comments) {
		this.comments = comments;
	}
	public Long getUserProfileId() {
		return userProfileId;
	}
	public void setUserProfileId(Long userProfileId) {
		this.userProfileId = userProfileId;
	}

}