package gov.va.med.mhv.vitals.model;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
@Entity
@Table(name="LIPIDS_READINGS")
public class LipidsReading implements Serializable{

	private static final long serialVersionUID = -6390439039840540750L;
	
	@Id
	@Column(name="LIPIDS_ID")
	@GeneratedValue(strategy=GenerationType.AUTO)
	private Long id;
	
	@Column(name="OPLOCK")
	private Integer oplock;
	
	@Column(name="COMMENTS")
	private String comments;
	
	@Column(name="USER_PROFILE_USER_PROFILE_ID")
	private Long userprofileId;
	
	@Column(name="READING")
	private Date reading;
	
	
	@Column(name="PROVIDER")
	private String provider;
	
	
	@Column(name="LOCATION")
	private String location;
	
	@Column(name="FAST")
	private String fast;
	
	@Column(name="TOTAL")
	private BigDecimal total;
	
	@Column(name="HDL")
	private BigDecimal hdl;
	
	@Column(name="LDL")
	private BigDecimal ldl;
	
	@Column(name="TRIGLYCERIDES")
	private BigDecimal triglycerides;

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Integer getOplock() {
		return oplock;
	}

	public void setOplock(Integer oplock) {
		this.oplock = oplock;
	}

	public String getComments() {
		return comments;
	}

	public void setComments(String comments) {
		this.comments = comments;
	}

	public Long getUserprofileId() {
		return userprofileId;
	}

	public void setUserprofileId(Long userprofileId) {
		this.userprofileId = userprofileId;
	}

	public Date getReading() {
		return reading;
	}

	public void setReading(Date reading) {
		this.reading = reading;
	}

	public String getProvider() {
		return provider;
	}

	public void setProvider(String provider) {
		this.provider = provider;
	}

	public String getLocation() {
		return location;
	}

	public void setLocation(String location) {
		this.location = location;
	}

	public String getFast() {
		return fast;
	}

	public void setFast(String fast) {
		this.fast = fast;
	}

	public BigDecimal getTotal() {
		return total;
	}

	public void setTotal(BigDecimal total) {
		this.total = total;
	}

	public BigDecimal getHdl() {
		return hdl;
	}

	public void setHdl(BigDecimal hdl) {
		this.hdl = hdl;
	}

	public BigDecimal getLdl() {
		return ldl;
	}

	public void setLdl(BigDecimal ldl) {
		this.ldl = ldl;
	}

	public BigDecimal getTriglycerides() {
		return triglycerides;
	}

	public void setTriglycerides(BigDecimal triglycerides) {
		this.triglycerides = triglycerides;
	}


}
