
<--  Escalated  -->

// group by day
select TRUNC(SENT_DATE, 'DDD') MonthYear,
      count(*)
from SECURE_MESSAGE
where ESCALATED is not null
group by TRUNC(SENT_DATE, 'DDD')
order by TRUNC(SENT_DATE, 'DDD');

// group by week
select TRUNC(SENT_DATE, 'DAY') MonthYear,
      count(*)
from SECURE_MESSAGE
where ESCALATED is not null
group by TRUNC(SENT_DATE, 'DAY')
order by TRUNC(SENT_DATE, 'DAY');


// group by month
select TRUNC(SENT_DATE, 'MON') MonthYear,
      count(*)
from SECURE_MESSAGE
where ESCALATED is not null
group by TRUNC(SENT_DATE, 'MON')
order by TRUNC(SENT_DATE, 'MON');


// group by quarter
select TRUNC(SENT_DATE, 'Q') MonthYear,
      count(*)
from SECURE_MESSAGE
where ESCALATED is not null
group by TRUNC(SENT_DATE, 'Q')
order by TRUNC(SENT_DATE, 'Q');

// group by year
select TRUNC(SENT_DATE, 'YYYY') MonthYear,
      count(*)
from SECURE_MESSAGE
where ESCALATED is not null
group by TRUNC(SENT_DATE, 'YYYY')
order by TRUNC(SENT_DATE, 'YYYY');



//messages by provider/clinical team/triage member
select TRUNC(SENT_DATE, 'MON') MonthYear,
      count(*)
from SECURE_MESSAGE m
inner join ADDRESSEE a
on a.SECURE_MESSAGE_ID = m.SECURE_MESSAGE_ID
and a.ADDRESSEE_ROLE = 0
inner join SMS_USER s
on a.USER_ID = s.USER_ID
where SENT_DATE  is not null
and s.USER_TYPE = 1
and s.CLINICAL_USER_TYPE_ID = 1
group by TRUNC(SENT_DATE, 'MON')
order by TRUNC(SENT_DATE, 'MON');


//messages by patient
select TRUNC(SENT_DATE, 'MON') MonthYear,
      count(*)
from SECURE_MESSAGE m
inner join ADDRESSEE a
on a.SECURE_MESSAGE_ID = m.SECURE_MESSAGE_ID
and a.ADDRESSEE_ROLE = 0
inner join SMS_USER s
on a.USER_ID = s.USER_ID
where SENT_DATE  is not null
and s.USER_TYPE = 0
group by TRUNC(SENT_DATE, 'MON')
order by TRUNC(SENT_DATE, 'MON');


// total messages sent
select TRUNC(SENT_DATE, 'MON') MonthYear,
      count(*)
from SECURE_MESSAGE m
where SENT_DATE  is not null
group by TRUNC(SENT_DATE, 'MON')
order by TRUNC(SENT_DATE, 'MON');




// messages read
select TRUNC(m.SENT_DATE, 'MON') MonthYear,
         sum(
           case 
           when 
             (select count(b.ADDRESSEE_ID) 
              from ADDRESSEE b
              inner join SMS_USER x
              on x.USER_ID = b.USER_ID
              where b.SECURE_MESSAGE_ID = m.SECURE_MESSAGE_ID 
              and x.USER_TYPE = 1
              and b.ADDRESSEE_ROLE = 1
              and b.READ_DATE is not null) > 0 then 1
           else 0
           end) as READ
from SECURE_MESSAGE m
where m.SENT_DATE is not null
group by TRUNC(m.SENT_DATE, 'MON')
order by TRUNC(m.SENT_DATE, 'MON');

// message unread
select TRUNC(m.SENT_DATE, 'MON') MonthYear,
         sum(
           case 
           when 
             (select count(b.ADDRESSEE_ID) 
              from ADDRESSEE b
              inner join SMS_USER x
              on x.USER_ID = b.USER_ID
              where b.SECURE_MESSAGE_ID = m.SECURE_MESSAGE_ID 
              and x.USER_TYPE = 1
              and b.ADDRESSEE_ROLE = 1
              and b.READ_DATE is not null) > 0 then 0
           else 1
           end) as UNREAD
from SECURE_MESSAGE m
where m.SENT_DATE is not null
group by TRUNC(m.SENT_DATE, 'MON')
order by TRUNC(m.SENT_DATE, 'MON');


// messages saved progress notes

