select u.USER_ID, 
       (select count(*) 
        from ADDRESSEE a 
        inner join SECURE_MESSAGE m
        on m.SECURE_MESSAGE_ID = a.SECURE_MESSAGE_ID
        where a.USER_ID=u.USER_ID 
        and m.SENT_DATE BETWEEN to_date('2008-MAY-01 00:00:00', 'YYYY-MON-DD HH24:MI:SS')
            and  to_date('2008-MAY-29 23:59:59', 'YYYY-MON-DD HH24:MI:SS')
        and READ_DATE is not null
        ) as READ,
       (select 
         sum(
           case 
           when 
             (select count(ADDRESSEE_ID) 
              from ADDRESSEE b
              inner join SMS_USER x
              on x.USER_ID = b.USER_ID
              where a.SECURE_MESSAGE_ID = b.SECURE_MESSAGE_ID 
              and x.USER_TYPE = 1
              and b.ADDRESSEE_ROLE = 1
              and b.READ_DATE is not null) > 0 then 0
           else 1
           end)
         from ADDRESSEE a
         inner join SECURE_MESSAGE m
         on m.SECURE_MESSAGE_ID = a.SECURE_MESSAGE_ID
         where a.USER_ID = u.USER_ID
         and m.SENT_DATE BETWEEN to_date('2008-MAY-01 00:00:00', 'YYYY-MON-DD HH24:MI:SS')
            and  to_date('2008-MAY-29 23:59:59', 'YYYY-MON-DD HH24:MI:SS')
         and a.ADDRESSEE_ROLE = 1) as UNREAD,
       (select count(m.SECURE_MESSAGE_ID) 
        from SECURE_MESSAGE m
        inner join ADDRESSEE a
        on a.SECURE_MESSAGE_ID = m.SECURE_MESSAGE_ID
        where a.USER_ID = u.USER_ID
        and m.SENT_DATE BETWEEN to_date('2008-MAY-01 00:00:00', 'YYYY-MON-DD HH24:MI:SS')
            and  to_date('2008-MAY-29 23:59:59', 'YYYY-MON-DD HH24:MI:SS')
        and m.ESCALATED is not null) as ESCALATED,
        (select count(*) 
         from TIU_CREATION_RECORD tiu
         inner join MESSAGE_THREAD t
         on t.THREAD_ID = tiu.THREAD_ID
         inner join SECURE_MESSAGE m
         on m.THREAD_ID = t.THREAD_ID
         inner join ADDRESSEE a
         on a.SECURE_MESSAGE_ID = m.SECURE_MESSAGE_ID
         where a.USER_ID = u.USER_ID
         and tiu.MODIFIED_DATE BETWEEN to_date('2008-MAY-01 00:00:00', 'YYYY-MON-DD HH24:MI:SS')
            and  to_date('2008-MAY-29 23:59:59', 'YYYY-MON-DD HH24:MI:SS')) as PROGRESS_NOTE,
        (select count(*) 
         from ADDRESSEE a 
         inner join SECURE_MESSAGE m
         on m.SECURE_MESSAGE_ID = a.SECURE_MESSAGE_ID
         where a.USER_ID = u.USER_ID
         and m.SENT_DATE BETWEEN to_date('2008-MAY-01 00:00:00', 'YYYY-MON-DD HH24:MI:SS')
            and  to_date('2008-MAY-29 23:59:59', 'YYYY-MON-DD HH24:MI:SS')) as TOTAL
from SMS_USER u
inner join FACILITIES f
on u.STATION_NO = f.STATIONNUMBER
inner join FACILITIES visn
on f.VISN_ID = visn.ID
where u.CLINICAL_USER_TYPE_ID = 1
and visn.NAME = 'VISN 6'
group by u.USER_ID;