package gov.va.med.mhv.sm.enumeration;

public enum MessagesOrderByEnum {

	/* the numeric values mean nothing except for
	 * possibly using them as parameters in the web tier
	 */
	FROM(1),
	SUBJECT(2),
	DATE(3),
	ASSIGNED(4),
	STATUS(5),
	TO(6),
	CREATED_DATE(7),
	READ_RECEIPT(8),
	CPRSALERTS_DATE(9);
	
	private int id;
	
	private MessagesOrderByEnum(int id){
		this.id = id;
	}
	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public static MessagesOrderByEnum valueOf(int value){
		for(MessagesOrderByEnum f : MessagesOrderByEnum.values()){
			if(f.getId() == value)
				return f;
		}
		/* none found; return default */
		return DATE;
	}
}
