package gov.va.med.mhv.sm.model;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import gov.va.med.mhv.sm.enumeration.ParticipantTypeEnum;
import gov.va.med.mhv.sm.enumeration.UserTypeEnum;


/**
 * 
 * @author vhalommccarw
 *
 *  represents a specific actor of provider
 *  
 */
public class Clinician extends User implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = -7110051897149899782L;

	@SuppressWarnings("unused")
	private static final Log log = LogFactory.getLog(Clinician.class);
	
	private String stationNo;
	private String duz;
	//list of distribution groups that the actor belongs 
	protected List<DistributionGroup> distGroups;
	// this determines if the user can create/sign TIU progress notes
	protected String provider;
	protected String providerVistAActiveFlag;
	protected String providerPcmmFlag;
	protected String requiresCosigner;
	protected String personClass;
	protected String providerClass;
	protected String dmmsUnits;
	
	
	private ClinicalUserType clinicalUserType;
	
	public Clinician(){
		super();
		this.userType = UserTypeEnum.CLINICIAN;
		this.participantType = ParticipantTypeEnum.CLINICIAN;
	}
	
	public String getStationNo() {
		return stationNo;
	}
	public void setStationNo(String stationNo) {
		this.stationNo = stationNo;
	}
	public String getDuz() {
		return duz;
	}
	public void setDuz(String duz) {
		this.duz = duz;
	}
	public List<DistributionGroup> getDistGroups() {
		return distGroups;
	}
	public void setDistGroups(List<DistributionGroup> distGroups) {
		this.distGroups = distGroups;
	}
	
	public ClinicalUserType getClinicalUserType() {
		return clinicalUserType;
	}
	
	public void setClinicalUserType(ClinicalUserType clinicalUserType) {
		this.clinicalUserType = clinicalUserType;
	}
	

	
	public boolean equals(Object a){
		try{
			Clinician x = (Clinician)a;
			if(this.getId().equals(x.getId())) 
				return true;
			return false;
		}catch(Exception e){
			return false;
		}
	} 
 
	public int hashCode(){
		return this.getId().hashCode();
	}

	public String getProviderVistAActiveFlag() {
		return providerVistAActiveFlag;
	}

	public void setProviderVistAActiveFlag(String providerVistAActiveFlag) {
		this.providerVistAActiveFlag = providerVistAActiveFlag;
	}

	public String getProviderPcmmFlag() {
		return providerPcmmFlag;
	}

	public void setProviderPcmmFlag(String providerPcmmFlag) {
		this.providerPcmmFlag = providerPcmmFlag;
	}

	public String getRequiresCosigner() {
		return requiresCosigner;
	}

	public void setRequiresCosigner(String requiresCosigner) {
		this.requiresCosigner = requiresCosigner;
	}

	public String getPersonClass() {
		return personClass;
	}

	public void setPersonClass(String personClass) {
		this.personClass = personClass;
	}

	public String getProviderClass() {
		return providerClass;
	}

	public void setProviderClass(String providerClass) {
		this.providerClass = providerClass;
	}


	public String getDmmsUnits() {
		return dmmsUnits;
	}

	public void setDmmsUnits(String dmmsUnits) {
		this.dmmsUnits = dmmsUnits;
	}
	
	public String getProvider() {
		return provider;
	}

	public void setProvider(String provider) {
		this.provider = provider;
	}
}
