package gov.va.med.mhv.sm.service;

import gov.va.med.mhv.foundation.service.Service;
import gov.va.med.mhv.foundation.service.response.CollectionServiceResponse;
import gov.va.med.mhv.foundation.service.response.ServiceResponse;
import gov.va.med.mhv.sm.enumeration.CountsSubCategoryEnum;
import gov.va.med.mhv.sm.enumeration.ListsSubCategoryEnum;
import gov.va.med.mhv.sm.enumeration.ReportingFilterTypeEnum;
import gov.va.med.mhv.sm.enumeration.ReportingPeriodEnum;
import gov.va.med.mhv.sm.model.report.CountsResults;
import gov.va.med.mhv.sm.model.report.ListsResults;
import gov.va.med.mhv.sm.model.report.ResultKey;

import java.util.Date;
import java.util.List;

public interface ReportsService extends Service{

	public ServiceResponse<CountsResults> runCountsReport(Date start, Date end, ReportingPeriodEnum period, List<CountsSubCategoryEnum> subCategories, ReportingFilterTypeEnum filter, ResultKey mainId, List<ResultKey> keys);
	
	public CollectionServiceResponse<ListsResults> runListsReport(List<ListsSubCategoryEnum> subCategories, ReportingFilterTypeEnum filter, ResultKey mainId, List<ResultKey> keys);
}
