package gov.va.med.mhv.sm.util;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class RotateListUtil {
	private static final Log log = LogFactory.getLog(RotateListUtil.class);
	
	public static Object[] rotate(int cols, Object[] list) {
		List<Object> l = new ArrayList<Object>();
		for(Object i: list)
			l.add(i);
		return rotate1(cols,l).toArray();
	}
	
//	public static void main(String ar[]) {
//		Object[] res = rotate(3,new CountsSubCategoryEnum[]{CountsSubCategoryEnum.ACTION_PENDING_PATIENTS,CountsSubCategoryEnum.ACTIVE_PATIENTS,CountsSubCategoryEnum.BLOCKED_PATIENTS});
//		System.out.println(((CountsSubCategoryEnum)res[0]).getDescription());
//	}
//	
//
	public static List rotate1(int cols, List<Object> list) {
		int siz = list.size() / cols;
		int mod = list.size() % cols;

		int colslength[] = new int[cols];

		int max = siz + (mod == 0 ? 0 : 1);
		int tlength = siz;
		if(log.isInfoEnabled()) 
			log.info("mod=" + mod + ",siz=" + siz + ",max=" + max);
		
		for (int i = 0; i < cols; i++) {
			if (i < mod) {
				colslength[i] = tlength + 1;
			} else {
				colslength[i] = tlength;
			}
		}
		if(log.isInfoEnabled()) 
			log.info("colslength[2]="+colslength[2]);
		List<Object> remapped = new ArrayList<Object>();
		List[] buckets = new List[cols];
		int last = 0;
		for( int i=0;i<cols;i++) {
			buckets[i] = new ArrayList<Object>();
			if( i!=0) last+=colslength[i-1];
			if(log.isInfoEnabled()) 
				log.info("sublist "+(last)+","+(i==0?colslength[i]:(last+colslength[i])));
			for(Object o: list.subList(last,(i==0?colslength[i]:(last+colslength[i])))) {
				buckets[i].add(o);
				if(log.isInfoEnabled()) 
					log.info("Process:" + o);
			}
		}
		
		for( int i=0;i<max;i++){
			for(int b=0;b<cols;b++) {
				if( buckets[b].size()>0)
					remapped.add(buckets[b].remove(0));
			}
		}
		
		if(log.isInfoEnabled()) 
			log.info("Returned:" + remapped);
		return remapped;
	}
	
//	public static List rotate(int cols, List<Object> list) {
//		int siz = list.size() / cols;
//		int mod = list.size() % cols;
//
//		int colslength[] = new int[cols];
//
//		int max = siz + (mod == 0 ? 0 : 1);
//		int tlength = siz;
//		if(log.isInfoEnabled()) 
//			log.info("mod=" + mod + ",siz=" + siz + ",max=" + max);
//		
//		for (int i = 0; i < cols-1; i++) {
//			if (i < mod) {
//				colslength[i] = tlength + 1;
//			} else {
//				colslength[i] = tlength;
//			}
//			if (i > 0) {
//				colslength[i] = colslength[i] + colslength[i - 1];
//			}
//		}
//
//		List<Object> remapped = new ArrayList<Object>();
//		
//		for (int r = 0; r < max; r++) {
//			if (r < list.size()) {
//				 System.out.println("-"+r+" " + list.get(r));
//				 remapped.add(list.get(r));
//			}
//			for (int p = 0; p < cols-1; p++) {
//				int offset = colslength[p];
//				if (r + offset < list.size()) {
//					System.out.println("+"+(r + offset)+" " + list.get(r+offset));
//					remapped.add(list.get(r+offset));
//				}
//			}
//		}
//		int c = 0;
//		String line = "";
//		for (Object o : remapped) {
//			if (c % cols == 0) {
//				if(log.isInfoEnabled()) 
//					log.info(line);
//				line="";
//			}
//			if(log.isInfoEnabled()) 
//				line+=(o + " ");
//			c++;
//		}
//		if(log.isInfoEnabled()) 
//			log.info(line);
//		
//		if(log.isInfoEnabled()) 
//			log.info("Returned:" + remapped);
//		
//		return remapped;
//	}
	
}
