package gov.va.med.mhv.foundation.web.xwork.interceptor;

import gov.va.med.mhv.foundation.util.Precondition;
import gov.va.med.mhv.foundation.web.util.NoCacheResponseHandler;

import javax.servlet.http.HttpServletResponse;

import org.apache.struts2.StrutsStatics;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionInvocation;
import com.opensymphony.xwork2.interceptor.AbstractInterceptor;

public class NoCacheResponseInterceptor extends AbstractInterceptor {

	private static final long serialVersionUID = 2059502953238080890L;
	
	private final NoCacheResponseHandler handler;
	
	public NoCacheResponseInterceptor() {
		handler = new NoCacheResponseHandler();
		handler.init();
	}

	@Override
	public String intercept(ActionInvocation invocation) throws Exception {
		Precondition.assertNotNull("invocation", invocation);
		final ActionContext context = invocation.getInvocationContext();
		Precondition.assertNotNull("invocation.invocationContext", context);

		handler.apply((HttpServletResponse) context.get(StrutsStatics.
			HTTP_RESPONSE));
		
		return invocation.invoke();
	}
}
