package gov.va.med.mhv.foundation.util;

import org.apache.commons.logging.Log;

/**
 * Provided a {@link Log} instance.  
 * This allows the concrete class to delegate functionality to another class,
 * but retain the possibility to log information in the delegating class's
 * log category.
 * @author Rob Proper
 */
public interface Loggable {

	/**
	 * Return The {@link Log} instance of the concrete class.
	 * Returning null is allowed, but not recommended. 
	 * When null is returned the caller typically will use its own log
	 * instance, whereby valuable information may be lost.
	 * @return The log instance.  
	 */
	Log getLog();
	
}
