<%@ taglib prefix="s" uri="/struts-tags" %>

<%@ page import="java.util.Collection"%>
<%@ page import="java.io.StringWriter"%>
<%@ page import="gov.va.med.mhv.sm.web.smActions.Authenticate"%>
<%@ page import="gov.va.med.mhv.sm.web.utils.ut" %>
<%@ page import="gov.va.med.mhv.sm.enumeration.UserTypeEnum" %>

<%!
	private String showLoginErrorsAsUnorderedList(HttpSession session) {
	
		// The user can be successfully authenticated against the container,
		// but the credentials provided by the user may conflict with the 
		// original request. In this case the session should be invalidated 
		// and the browser redirected to the original request. This will force 
		// the user to re-authenticate and provide the correct credentials.
		// Redirection must be used to such that the original request is 
		// not lost.
		//
		// When redirecting, the only means of passing (error) information 
		// is thru the session, thus a session attribute is used to store 
		// login error, rather than using an action, because upon a browser
		// redirect the action information is lost.
		//
		// This method display this error information as an unordered list.
		StringWriter writer = new StringWriter(); 
		Collection<?> errors = (Collection<?>) session.getAttribute(
			Authenticate.SESSION_ATTRIBUTE_LOGIN_ERRORS);
		if (errors != null) {
			writer.write("\n<ul>\n");
			for (Object error: errors) {
				if (error != null) {
					writer.write("<li>");
					writer.write("<span class=\"errorMessage\"");
					writer.write("style=\"color:red;font-weight:bold;\">");
					writer.write(error.toString());
					writer.write("</span>");
					writer.write("</li>\n");
				}
			}
			writer.write("</ul>\n");
		}
		return writer.toString();
	}
%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="en">
<head>
<title>My HealtheVet - Secure Messaging - Inbox</title>
<meta name="Title" content="My HealtheVet - Secure Messaging - Inbox" />
<meta name="Creator" content="My HealtheVet" />
<meta name="Subject" content="Secure Messaging" />
<meta name="Description" content="Secure Messaging - Login Page" />
<meta name="Keywords" content="Secure Messaging" />
<meta name="Type" content="Application" />
<meta name="Language" content="en-US" />
<meta name="DateCreated" content="20080101" />

	<link rel="stylesheet" media="all" href="css/sms_styles.css" type="text/css" />
	<link rel="stylesheet" media="all" href="css/sms_styles-ie.css" type="text/css" />
</head>

<body>

<table width="100%" cellpadding="0" cellspacing="0" border="0"  class="sm_table">
	<tr><td class="sm_header"><img src="images/sms/sm_header_r1_c1.jpg"  alt="My HealtheVet" style="border:0px;" ></td>
		<td class="sm_header_right" valign="middle" align="right"><p>
			<a href="javascript:self.close()" onClick="window.close();"><img src="images/sms/btn_closeSecureMessaging.jpg" width="155" height="27" alt="Close Secure Messaging" style="border:0px;" ></a>
			



<%-- ADD CONDITIONAL LOGIC TO DISPLAY APPROPRIATE MESSAGE --%>

</p></td></tr>
	<tr><td colspan="2"><table width="100%" cellpadding="0" cellspacing="0" border="0">
	<tr class="sm_title_row"><td class="sm_title_header" valign="middle" align="left"><h1>Secure Messaging</h1></td>
		<td class="sm_title_header_right" valign="middle" align="right" ><img src="images/sms/sm_header_r2_c2.jpg" width="470" height="43" alt="SM Header" border="0" /></td></tr>
	</table></td></tr>
<tr><td colspan="2" valign="top" align="left" class="sm_main_cell">
	<table width="100%" cellpadding="0" cellspacing="0" border="0"  id="sm_boxTable">
		<tr><td valign="top" align="left" width="6" class="sm_boxLeft"><img src="images/sms/border_topLeft.gif" width="6" height="13" alt="Border Top Left" border="0" /></td>

			<td valign="top" align="left" class="sm_box" ><table cellpadding="0" cellspacing="0" border="0" >
						
				<tr><td valign="top" align="left">
<!-- START LOGIN FORM CODE -->
			<table id="sms-Login" cellpadding="0" cellspacing="0" border="0" align="right"><tr><td valign="top" align="left">
<%
	UserTypeEnum userType = ut.getUserTypeBasedOnHostInRequest(request);
	String userIdLabel;
	if (userType == UserTypeEnum.CLINICIAN) {
	   userIdLabel = "Network ID";
    } else {
       userIdLabel = "MHV User ID";
    }
%>
			<h2>Please log in using your <%=userIdLabel%> and password</h2>
			<form action="j_security_check" method="POST">
			<s:actionerror cssStyle="color: red;font-weight:bold;"/>

			<%= showLoginErrorsAsUnorderedList(session) %>
            <s:fielderror cssStyle="color: red;font-weight:bold;"/>
			<p>Username:<br />
			<s:textfield size="36" id="sm_username" name="j_username" />
            <p>Password:<br />
			<s:password size="35" id="sm_password" name="j_password"/>
			
			</p>
						<% if(session.getAttribute("CLINICIANSTATUS")!=null)
						{
							if(session.getAttribute("CLINICIANSTATUS").equals("OPT_OUT"))
							{%>
								<jsp:include page="/tiles/global/clinicianOptOutMessageBox.jsp"/>
								
							<%}
						}%>
			<p align="right" class="noPad noMar"><input type="submit" value="Login" class="mhv-input-button" /></p>
			</form>
			&nbsp;<br>
			&nbsp;<br>
			&nbsp;<br>
			&nbsp;<br>
			&nbsp;<br>
			&nbsp;<br>
			&nbsp;<br>
			&nbsp;<br>
			&nbsp;<br>
			&nbsp;<br>
			&nbsp;<br>
			&nbsp;<br>
			&nbsp;<br>
			&nbsp;<br>
			&nbsp;<br>
			&nbsp;<br>
			&nbsp;<br>
			&nbsp;<br>

			</td>
			</tr>
			</table>
<!-- END LOGIN FORM CODE -->

					<!-- START INTRO TEXT -->
<jsp:include page="/tiles/global/global_introText.jsp"></jsp:include>
					<!-- END INTRO TEXT --></td></tr></table></td>
			<td valign="top" align="left" width="7" class="sm_boxRight"><img src="images/sms/border_topRight.gif" width="7" height="13" alt="" border="0" /></td></tr>
		<tr class="borderLine">
			<td valign="top" align="left" width="6"><img src="images/sms/border_btmLeft.gif" width="6" height="13" alt="" border="0" /></td>

			<td valign="top" align="left" class="sm_boxBottom"><img src="images/spacer.gif" width="1" height="1" alt="" border="0" /></td>
			<td valign="top" align="left" width="7"><img align="absbottom" src="images/sms/border_btmRight.gif" width="7" height="13" alt="" border="0" /></td></tr>
	</table></td></tr>

</table>
</body>

</html>
