
<%@ taglib uri="http://tiles.apache.org/tags-tiles" prefix="tiles"%>
<%@ taglib uri="/WEB-INF/esapi.tld" prefix="esapi" %>
<%@ page
  import="org.apache.commons.logging.Log"
  import="org.apache.commons.logging.LogFactory"
  import="gov.va.med.mhv.sm.model.Addressee"
  import="gov.va.med.mhv.sm.model.Folder"
  import="gov.va.med.mhv.sm.model.Message"
  import="gov.va.med.mhv.sm.model.MessagesPage"
  import="gov.va.med.mhv.sm.model.MailParticipant"
  import="gov.va.med.mhv.sm.model.User"
  import="gov.va.med.mhv.sm.model.Patient"
  import="gov.va.med.mhv.sm.model.Clinician"
  import="gov.va.med.mhv.sm.model.Thread"
  import="gov.va.med.mhv.sm.util.DateUtils"
  import="gov.va.med.mhv.sm.enumeration.SystemFolderEnum"
  import="gov.va.med.mhv.sm.enumeration.AddresseeRoleEnum"
  import="gov.va.med.mhv.sm.web.smActions.AbstractInboxAction"
  import="org.owasp.esapi.ESAPI"
  import="java.util.List"
  import="org.apache.commons.lang.StringEscapeUtils"  
%>
<%
  String selectMsgsOption = "none";
	try
	{
	  selectMsgsOption = (request.getParameter("selectMsgsOpt") == null)?"none":request.getParameter("selectMsgsOpt");
	}catch(Exception e)
	{
		selectMsgsOption="none";
	}
	String checkedVal = "";
	if(selectMsgsOption.equalsIgnoreCase("all"))
	{
	  checkedVal = "checked";
	}
	List<String> selectedMessages = (List<String>)session.getAttribute("unconfirmed.messages.for.deletion");
%>

<%--
  This page should not be responsible for fetching the messages.
  Only for displaying the messages that happen to exist in the
  session("activeFolder").getMessagesPage()
--%>

<%--
  If we are in the drafts folder then the link for the message
  should be to compose (edit), not read message
--%>

<%!private static Log log =LogFactory.getLog("jsp.gov.va.med.mhv.sm.clinician_Inbox_messages");%>

<%
  Folder folder=(Folder)session.getAttribute(AbstractInboxAction.CURRENT_FOLDER);
  boolean isCPRSAlersFolder =  folder.getId().equals(SystemFolderEnum.CPRSPROGRESSALERTS.getId());
	String activeFolderName = folder.getName();
	String messageChkType = "checkbox";
	if(activeFolderName.equals("Sent") || activeFolderName.equals("Escalated") || activeFolderName.equals("Completed") || activeFolderName.equals("Reassign")){messageChkType = "hidden";}
	String messageChkImg  = "";
  MessagesPage messages = folder.getMessages();
  boolean isDraftsFolder = folder.getId().equals(SystemFolderEnum.DRAFTS.getId());
  boolean isSentFolder = folder.getId().equals(SystemFolderEnum.SENT.getId());
	String textForCheckbox = "";
  if(messages == null){
	log.error("The messages object is not valid");
	%>
	  <tr ><td colspan="7" valign="middle" align="center"><br /><strong>No Messages Found (Error Occurred)</strong><br />&nbsp;</td></tr>
	<%
	return;
  }
  if(messages.getElementCount() == 0){
    %>
      <tr ><td colspan="7" valign="middle" align="center"><br /><strong>No Messages Found</strong><br />&nbsp;</td></tr>
    <%
	return;
  }

  boolean odd = false;
  String unread = "";
  for(Addressee a : messages.getElements()){
  	  if(selectedMessages!=null) checkedVal="";
	  if(a.getReadDate() == null){
		  unread = "font-weight:bold;";
		  if(selectMsgsOption.equalsIgnoreCase("unread")){
		  	checkedVal = "checked";
		  }else if(selectMsgsOption.equalsIgnoreCase("read")){
		  	checkedVal = "";
		  }
	  }else{
		  unread = "";
		  if(selectMsgsOption.equalsIgnoreCase("read")){
		  	checkedVal = "checked";
		  }else if(selectMsgsOption.equalsIgnoreCase("unread")){
		  	checkedVal = "";
		  }
	  }
	  Message m = a.getMessage();
	  Thread t = m.getThread();
	  odd = !odd;
	  String style = "";
	  if(odd){
        style = "sm_inbox_odd";
	  }else{
		style =  "sm_inbox_even";
	  }
	  if(messageChkType.equals("hidden"))
		{
	    if(odd)
			{
        messageChkImg="<img src='images/sms/inbox_white.jpg' alt='White inbox'>";
	    }
			else
			{
		    messageChkImg="<img src='images/sms/inbox_blue.jpg' alt='Blue inbox'>";
			}
		}
		else
		{
			messageChkImg="";
		}
	%>
    <tr class="<%=style %>">
		  <td width="15">
				<%=messageChkImg%>
				<%
				if(messageChkType.equals("checkbox")){
				%>	
				<label for="messageChk-<%=m.getId()%>">
					<%
					if(!isDraftsFolder){
						textForCheckbox = "Message from " + m.getSenderName();						
					}else{
						textForCheckbox = "Draft message.";
					}
						textForCheckbox += " Subject: " + t.getSubject();
					%>
					<img width="1" height="1" alt="<esapi:encodeForHTMLAttribute><%=textForCheckbox%></esapi:encodeForHTMLAttribute>" src="images/spacer.gif">
				</label>
				<%	
				}
				%>
				<%
					if(selectedMessages!=null && selectedMessages.contains(m.getId())){
						checkedVal="checked";
					}
				%>
				<input type="<%=messageChkType%>" name="messageChk" id="messageChk-<%=m.getId()%>" value="<esapi:encodeForHTMLAttribute><%=m.getId()%></esapi:encodeForHTMLAttribute>" <%=checkedVal%> />
			</td>
<%
if (!isSentFolder) {
%>
	    <td style="<%=unread %>"><esapi:encodeForHTML><%=m.getSenderName()%></esapi:encodeForHTML></td>
<%
}
%>
	    <td style="<%=unread %>"><esapi:encodeForHTML><%=m.getRecipientName()%></esapi:encodeForHTML></td>
	    <td style="<%=unread %>">

	      <% if(!isDraftsFolder){ %>
	        <a href="ReadMessage.action?messageId=<%=m.getId() %>">
	        <%
	        	if(a.getRole().equals(AddresseeRoleEnum.CC) || a.getRole().equals(AddresseeRoleEnum.CC_SURROGATE)){
	        		out.print("CC: "+t.getSubject());
	        	}else{
	        		out.print(t.getSubject());
	        	}
	        %>
	    	  <!--  <%=t.getSubject()%>-->  
	        </a>&nbsp;&nbsp;
	        <%
	        	if(m.isAttachment()){
	        %>
	        <img src='images/attachment.gif' border="0" alt='attachment picture'> 
	        <%}%>
	      <% }else{
	    	  String editDraftUrl = "";
        	  if(t.getMessages().size()==1)
        	  {
        		 editDraftUrl = "editDraft.action?messageId="+m.getId();
        	  }
        	  else
        	  {
				 editDraftUrl = "editReplyDraft.action?messageId="+m.getId();        		  
        	  }
	    	  %>
	        <a href="<%=editDraftUrl%>">
              <esapi:encodeForHTML><%=StringEscapeUtils.unescapeHtml(t.getSubject())%></esapi:encodeForHTML>
            </a>
	      <% } %>
	    </td>
		<td style="<%=unread %>">
			<%=DateUtils.getEnglishDateTime( (folder.getId() == SystemFolderEnum.DRAFTS.getId()?m.getCreatedDate():m.getSentDate()) ) %>
		</td>
		
<%
if(isCPRSAlersFolder){%>
<td style="<%=unread %>">
	<%=DateUtils.getEnglishDateTime(m.getCprsNotesFailedDate()) %>
</td>
<%}%>
	    
		<%if (!isSentFolder && !isDraftsFolder) {%>
	    <td>	<%
	    
	    		if(m.getAssignedTo()!=null && m.getAssignedTo().getName()!=null){
	    			out.println(ESAPI.encoder().encodeForHTML(m.getAssignedTo().getName()));	
	    		}else{
	    			out.println("&nbsp;");	
	    		}
	    		%>
	    </td>	
	    <%}%>
	    
	    <%if (!isSentFolder && !isDraftsFolder) {
			%>
		    <td><esapi:encodeForHTML><%=m.getStatus().getStatus()%></esapi:encodeForHTML>&nbsp;</td>
		<%} %>    
	    <%if (isSentFolder) {
			String readReceipt = m.getReadReceipt();
			if(readReceipt==null)readReceipt = "";		    
		%>	
		    <td><esapi:encodeForHTML><%=readReceipt%></esapi:encodeForHTML>&nbsp;</td>
	    <%}%>
</tr>
	    
	<%
  }
%>
